        ;Message system variables

msgnum:         dc.b $ff
msgtime:        dc.b 0
msgcnt:         dc.b 0

        ;Other interrupt tables/variables

scrd018:        dc.b $80,$90
scrframetbl:    dc.b #>SCREEN1+3,#>SCREEN2+3

        ;Advance for spriteIRQs, according to amount of sprites

sprirqpostbl:   dc.b 4,5,5,6,6,7,7,12

        ;Bits for $d015
ontable:        dc.b 0
                dc.b 128
                dc.b 128+64
                dc.b 128+64+32
                dc.b 128+64+32+16
                dc.b 128+64+32+16+8
                dc.b 128+64+32+16+8+4
                dc.b 128+64+32+16+8+4+2
                dc.b 128+64+32+16+8+4+2+1

        ;$d010-or table
ortable:        REPEAT MAX_SPR*2/8
                dc.b 128
                dc.b 64
                dc.b 32
                dc.b 16
                dc.b 8
                dc.b 4
                dc.b 2
                dc.b 1
                REPEND

        ;$d010-and table
andtable:       REPEAT MAX_SPR*2/8
                dc.b 255-128
                dc.b 255-64
                dc.b 255-32
                dc.b 255-16
                dc.b 255-8
                dc.b 255-4
                dc.b 255-2
                dc.b 255-1
                REPEND

physsprtbl:     REPEAT MAX_SPR*2/8
                dc.b 7
                dc.b 6
                dc.b 5
                dc.b 4
                dc.b 3
                dc.b 2
                dc.b 1
                dc.b 0
                REPEND

physsprtbl2:    REPEAT MAX_SPR*2/8
                dc.b 14
                dc.b 12
                dc.b 10
                dc.b 8
                dc.b 6
                dc.b 4
                dc.b 2
                dc.b 0
                REPEND

        ;Sprite + spritemultiplexing arrays

sprf:           ds.b MAX_SPR,0
sprx:           ds.b MAX_SPR,0
sprxh:          ds.b MAX_SPR,0
sprfls:         ds.b MAX_SPR,0

sortspry:       ds.b MAX_SPR*2,0
sortsprx:       ds.b MAX_SPR*2,0
sortsprxh:      ds.b MAX_SPR*2,0
sortsprf:       ds.b MAX_SPR*2,0
sortsprc:       ds.b MAX_SPR*2,0
sprirqline:     ds.b MAX_SPRIRQ*2,0
sprirqstart:    ds.b MAX_SPRIRQ*2,0
sprirqend:      ds.b MAX_SPRIRQ*2,0

        ;Background color flashing table

setbg:          dc.b 0,0,9,2,8
setmc1:         dc.b 0,8,10,7,1
setmc2:         dc.b 0,2,8,10,7

        ;Table for random enemy spawning Y-position (as blocks)

spawnytbl:      dc.b 1,2,2,3,3,4,4,5

        ;Actor array

shpxl:          ds.b MAX_SHP,0
shpxh:          ds.b MAX_SHP,0
shpyl:          ds.b MAX_SHP,0
shpyh:          ds.b MAX_SHP,0
shpt:           ds.b MAX_SHP,0
shpf:           ds.b MAX_SHP,0
shpfd:          ds.b MAX_SHP,0
shpd:           ds.b MAX_SHP,0
shpbits:        ds.b MAX_SHP,0
shpsx:          ds.b MAX_SHP,0
shpsy:          ds.b MAX_SHP,0
shporg:         ds.b MAX_SHP,0
shpp:           ds.b MAX_SHP,0
shpimm:         ds.b MAX_SHP,0

        ;Actor draw routines

upsh_routtbllo: dc.b <upsh_1x1
                dc.b <upsh_1x2
                dc.b <upsh_2x1
                dc.b <upsh_2x2
                dc.b <upsh_4x2
                dc.b <upsh_3x3
                dc.b <upsh_2x4
                dc.b <upsh_2x2

upsh_routtblhi: dc.b >upsh_1x1
                dc.b >upsh_1x2
                dc.b >upsh_2x1
                dc.b >upsh_2x2
                dc.b >upsh_4x2
                dc.b >upsh_3x3
                dc.b >upsh_2x4
                dc.b >upsh_2x2
        ;Table of actor structure addresses
shptbllo:       dc.b <shape1,<shape2,<shape3,<shape4
                dc.b <shape5,<shape6,<shape7,<shape8
                dc.b <shape9,<shape10,<shape11,<shape12
                dc.b <shape13,<shape14,<shape15,<shape16
                dc.b <shape17,<shape18,<shape19,<shape20
                dc.b <shape21,<shape22,<shape23,<shape24
                dc.b <shape25,<shape26,<shape27,<shape28
                dc.b <shape29,<shape30,<shape31,<shape32
                dc.b <shape33,<shape34,<shape35,<shape36
                dc.b <shape37,<shape38,<shape39,<shape40
                dc.b <shape41

shptblhi:       dc.b >shape1,>shape2,>shape3,>shape4
                dc.b >shape5,>shape6,>shape7,>shape8
                dc.b >shape9,>shape10,>shape11,>shape12
                dc.b >shape13,>shape14,>shape15,>shape16
                dc.b >shape17,>shape18,>shape19,>shape20
                dc.b >shape21,>shape22,>shape23,>shape24
                dc.b >shape25,>shape26,>shape27,>shape28
                dc.b >shape29,>shape30,>shape31,>shape32
                dc.b >shape33,>shape34,>shape35,>shape36
                dc.b >shape37,>shape38,>shape39,>shape40
                dc.b >shape41

        ;Table for actor moveroutines
movtbllo:       dc.b <movplr_run,<movplr_duck,<movplr_climb,<movplr_dead
                dc.b <itemrout,<movbullet,<explode,<shrapnel
                dc.b <blood,<dblexpl,<dblexpl,<punk
                dc.b <motorist,<jetpack,<terrorist,<cybergoat
                dc.b <robogoat,<bat,<punk_noshoot,<slime
                dc.b <pig,<gun,<droid,<craft
                dc.b <boss0,<boss1,<boss2,<boss3
                dc.b <donothing,<sign,<harris,<overman
                dc.b <yngwie,<donothing,<donothing,<donothing
                dc.b <donothing,<donothing,<donothing,<sadok
                dc.b <scienta

movtblhi:       dc.b >movplr_run,>movplr_duck,>movplr_climb,>movplr_dead
                dc.b >itemrout,>movbullet,>explode,>shrapnel
                dc.b >blood,>dblexpl,>dblexpl,>punk
                dc.b >motorist,>jetpack,>terrorist,>cybergoat
                dc.b >robogoat,>bat,>punk_noshoot,>slime
                dc.b >pig,>gun,>droid,>craft
                dc.b >boss0,>boss1,>boss2,>boss3
                dc.b >donothing,>sign,>harris,>overman
                dc.b >yngwie,>donothing,>donothing,>donothing
                dc.b >donothing,>donothing,>donothing,>sadok
                dc.b >scienta

        ;Actor 1 - player standing/running

shape1:         dc.b 12;X-hotspot
                dc.b 39;Y-hotspot
                dc.b SHP1x2 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 8;First left frame
                dc.b 6;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 32;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 65,68
                dc.b 65,69
                dc.b 64,70
                dc.b 66,68
                dc.b 66,69
                dc.b 64,70
                dc.b 64,67
                dc.b 65,71
                dc.b 73,76
                dc.b 73,77
                dc.b 72,78
                dc.b 74,76
                dc.b 74,77
                dc.b 72,78
                dc.b 72,75
                dc.b 73,79

        ;Actor 2 - player ducking

shape2:         dc.b 12;X-hotspot
                dc.b 30;Y-hotspot
                dc.b SHP1x2 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 1 ;First left frame
                dc.b 6;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 19;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 80,81
                dc.b 82,83

        ;Actor 3 - player climbing

shape3:         dc.b 11;X-hotspot
                dc.b 39;Y-hotspot
                dc.b SHP1x2 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 0 ;First left frame
                dc.b 6;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 32;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 84,87
                dc.b 85,88
                dc.b 84,87
                dc.b 86,89

        ;Actor 4 - player death

shape4:         dc.b 11;X-hotspot
                dc.b 39;Y-hotspot
                dc.b SHP1x2 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 1 ;First left frame
                dc.b 6;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 32;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 90,91
                dc.b 92,93

        ;Actor 5 - Items

shape5:         dc.b 12;X-hotspot
                dc.b 18;Y-hotspot
                dc.b SHP1x1 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 0 ;First left frame
                dc.b 6 ;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 15;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

itemframetbl:   dc.b 114,115,116,117,118,119,120,121,122,123,124,125,126,127

        ;Actor 6 - bullets

shape6:         dc.b 12
                dc.b 10
                dc.b SHP1x1
                dc.b 0
                dc.b 0
                dc.b 4
                dc.b 2
                dc.b 2

                dc.b 106,107,108,109,110,111,112,113

        ;Actor 7 - explosion

shape7:         dc.b 12
                dc.b 10
                dc.b SHP1x1
                dc.b 0
                dc.b 0
                dc.b 12
                dc.b 10
                dc.b 10

                dc.b 96,97,98,99,100

        ;Actor 8 - shrapnel

shape8:         dc.b 12
                dc.b 10
                dc.b SHP1x1
                dc.b 0
                dc.b 0
                dc.b 4
                dc.b 4
                dc.b 4

                dc.b 101,102,103

        ;Actor 9 - blood

shape9:         dc.b 12
                dc.b 10
                dc.b SHP1x1
                dc.b 0
                dc.b 0
                dc.b 4
                dc.b 4
                dc.b 4

                dc.b 104,105

        ;Actor 10 - double explosion

shape10:        dc.b 12
                dc.b 39
                dc.b SHP1x2
                dc.b 0
                dc.b 0
                dc.b 12
                dc.b 10
                dc.b 10

                dc.b 127,96
                dc.b 127,97
                dc.b 96,98
                dc.b 97,99
                dc.b 98,100
                dc.b 99,127
                dc.b 100,127

        ;Actor 11 - quad explosion

shape11:        dc.b 24
                dc.b 39
                dc.b SHP2x2
                dc.b 0
                dc.b 0
                dc.b 24
                dc.b 10
                dc.b 10

                dc.b 127,96,96,127
                dc.b 127,97,97,127
                dc.b 96,98,98,96
                dc.b 97,99,99,97
                dc.b 98,100,100,98
                dc.b 99,127,127,99
                dc.b 100,127,127,100

        ;Actor 12 - punk

shape12:        dc.b 12;X-hotspot
                dc.b 39;Y-hotspot
                dc.b SHP1x2 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 4 ;First left frame
                dc.b 6;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 32;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 128+32,131+32
                dc.b 129+32,132+32
                dc.b 128+32,131+32
                dc.b 130+32,133+32
                dc.b 134+32,137+32
                dc.b 135+32,138+32
                dc.b 134+32,137+32
                dc.b 136+32,139+32

        ;Actor 13 - motorist

shape13:        dc.b 24;X-hotspot
                dc.b 39;Y-hotspot
                dc.b SHP2x2 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 1 ;First left frame
                dc.b 20;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 30;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 140+32,141+32,142+32,143+32
                dc.b 144+32,145+32,146+32,147+32

        ;Actor 14 - jetpack man

shape14:        dc.b 12;X-hotspot
                dc.b 39;Y-hotspot
                dc.b SHP1x2 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 2 ;First left frame
                dc.b 6;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 32;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 148+32,150+32
                dc.b 149+32,150+32
                dc.b 151+32,153+32
                dc.b 152+32,153+32

        ;Actor 15 - terrorist

shape15:        dc.b 12;X-hotspot
                dc.b 39;Y-hotspot
                dc.b SHP1x2 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 4 ;First left frame
                dc.b 6 ;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 32;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 154+32,68
                dc.b 154+32,69
                dc.b 155+32,70
                dc.b 154+32,71
                dc.b 156+32,76
                dc.b 156+32,77
                dc.b 157+32,78
                dc.b 156+32,79

        ;Actor 16 - cybergoat

shape16:        dc.b 12;X-hotspot
                dc.b 41;Y-hotspot
                dc.b SHP1x2 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 4 ;First left frame
                dc.b 6 ;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 38;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 158+32,161+32
                dc.b 159+32,162+32
                dc.b 160+32,163+32
                dc.b 159+32,162+32
                dc.b 164+32,167+32
                dc.b 165+32,168+32
                dc.b 166+32,169+32
                dc.b 165+32,168+32

        ;Actor 17 - robogoat

shape17:        dc.b 12;X-hotspot
                dc.b 20;Y-hotspot
                dc.b SHP1x1 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 2 ;First left frame
                dc.b 10;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 20;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 170+32
                dc.b 171+32
                dc.b 172+32
                dc.b 173+32

        ;Actor 18 - bat

shape18:        dc.b 12;X-hotspot
                dc.b 10;Y-hotspot
                dc.b SHP1x1 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 4 ;First left frame
                dc.b 6 ;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 4 ;Vertical size from hotspot upwards
                dc.b 4 ;Vertical size from hotspot downwards

                dc.b 185+32,186+32,187+32,186+32
                dc.b 188+32,189+32,190+32,189+32

        ;Actor 19 - rat

shape19:        dc.b 12;X-hotspot
                dc.b 18;Y-hotspot
                dc.b SHP1x1 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 4 ;First left frame
                dc.b 10 ;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 7 ;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 191+32,192+32,193+32,192+32
                dc.b 194+32,195+32,196+32,195+32

        ;Actor 20 - slime blob

shape20:        dc.b 12;X-hotspot
                dc.b 18;Y-hotspot
                dc.b SHP1x1 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 2 ;First left frame
                dc.b 6 ;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 8 ;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 197+32,198+32
                dc.b 197+32,199+32

        ;Actor 21 - mutant pig

shape21:        dc.b 12;X-hotspot
                dc.b 20;Y-hotspot
                dc.b SHP1x1 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 2 ;First left frame
                dc.b 10 ;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 20 ;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 200+32,201+32
                dc.b 202+32,203+32

        ;Actor 22 - gun

shape22:        dc.b 12;X-hotspot
                dc.b 18;Y-hotspot
                dc.b SHP1x1 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 0 ;First left frame
                dc.b 8 ;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 17 ;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 174+32,175+32,176+32,175+32

        ;Actor 23 - droid

shape23:        dc.b 12;X-hotspot
                dc.b 10;Y-hotspot
                dc.b SHP1x1 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 0 ;First left frame
                dc.b 5 ;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 5 ;Vertical size from hotspot upwards
                dc.b 5 ;Vertical size from hotspot downwards

                dc.b 177+32,177+32,178+32,178+32

        ;Actor 24 - flying craft

shape24:        dc.b 12;X-hotspot
                dc.b 10;Y-hotspot
                dc.b SHP1x1 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 4 ;First left frame
                dc.b 10 ;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 7 ;Vertical size from hotspot upwards
                dc.b 7 ;Vertical size from hotspot downwards

                dc.b 179+32,180+32,179+32,181+32
                dc.b 182+32,183+32,182+32,184+32

        ;Actor 25 - boss 0

shape25:        dc.b 48;X-hotspot
                dc.b 39;Y-hotspot
                dc.b SHP4x2 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 0;First left frame
                dc.b 48;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 40;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 32,33,34,35
                dc.b 36,37,38,39

                dc.b 32,33,34,35
                dc.b 40,41,42,43

        ;Actor 26 - boss 1

shape26:        dc.b 24;X-hotspot
                dc.b 38;Y-hotspot
                dc.b SHP2x2B ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 0;First left frame
                dc.b 24;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 38;Vertical size from hotspot upwards
                dc.b 4;Vertical size from hotspot downwards

                dc.b 36,33
                dc.b 34,35

                dc.b 32,37
                dc.b 34,35

                dc.b 32,33
                dc.b 34,39

                dc.b 32,33
                dc.b 38,35

        ;Actor 27 - boss 2

shape27:        dc.b 36;X-hotspot
                dc.b 60;Y-hotspot
                dc.b SHP3x3 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 1;First left frame
                dc.b 33;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 60;Vertical size from hotspot upwards
                dc.b 0;Vertical size from hotspot downwards

                dc.b 32,33,34
                dc.b 35,36,37
                dc.b 38,39,40

                dc.b 41,42,43
                dc.b 44,45,46
                dc.b 47,48,49

        ;Actor 28 - boss 4

shape28:        dc.b 24;X-hotspot
                dc.b 42;Y-hotspot
                dc.b SHP2x4 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 2;First left frame
                dc.b 20;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 40;Vertical size from hotspot upwards
                dc.b 40;Vertical size from hotspot downwards

                dc.b 32,33
                dc.b 34,35
                dc.b 36,37
                dc.b 38,39

                dc.b 32,33
                dc.b 40,35
                dc.b 36,37
                dc.b 38,39

                dc.b 41,42
                dc.b 43,44
                dc.b 45,46
                dc.b 47,48

                dc.b 41,42
                dc.b 43,49
                dc.b 45,46
                dc.b 47,48

        ;Actor 29 - empty explosion for collision detection

shape29:        dc.b 12
                dc.b 10
                dc.b SHP1x1
                dc.b 0
                dc.b 0
                dc.b 40
                dc.b 40
                dc.b 40

                dc.b 127

        ;Actor 30 - the "visit here" hint sign

shape30:        dc.b 8
                dc.b 10
                dc.b SHP1x1
                dc.b 0
                dc.b 0
                dc.b 5
                dc.b 5
                dc.b 5

                dc.b 32,127

        ;Actor 31 - Faustus

shape31:        dc.b 12;X-hotspot
                dc.b 32;Y-hotspot
                dc.b SHP1x2 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 0;First left frame
                dc.b 6;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 24;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 32,34
                dc.b 32,34
                dc.b 33,34
                dc.b 32,34
                dc.b 33,34
                dc.b 33,34
                dc.b 32,34
                dc.b 33,34
                dc.b 52,34

        ;Actor 32 - Goat

shape32:        dc.b 16;X-hotspot
                dc.b 30;Y-hotspot
                dc.b SHP2x1 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 0;First left frame
                dc.b 16;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 24;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 35,37
                dc.b 36,37
                dc.b 49,48

        ;Actor 33 - Phantasm

shape33:        dc.b 12;X-hotspot
                dc.b 35;Y-hotspot
                dc.b SHP1x2 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 0;First left frame
                dc.b 6;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 28;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 38,42
                dc.b 39,42
                dc.b 40,42
                dc.b 41,42
                dc.b 50,51

        ;Actor 34 - Hitman

shape34:        dc.b 4;X-hotspot
                dc.b 35;Y-hotspot
                dc.b SHP1x2 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 0;First left frame
                dc.b 6;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 28;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 46,47

        ;Actor 35 - Detective

shape35:        dc.b 4;X-hotspot
                dc.b 37;Y-hotspot
                dc.b SHP1x1 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 0;First left frame
                dc.b 6;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 24;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 44

        ;Actor 36 - Shopkeeper in AXES&AMPS

shape36:        dc.b 12;X-hotspot
                dc.b 37;Y-hotspot
                dc.b SHP1x1 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 0;First left frame
                dc.b 6;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 24;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 43

        ;Actor 37 - Shopkeeper in weapon shop

shape37:        dc.b 12;X-hotspot
                dc.b 37;Y-hotspot
                dc.b SHP1x1 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 0;First left frame
                dc.b 6;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 24;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 44

        ;Actor 38 - bartender

shape38:        dc.b 12;X-hotspot
                dc.b 45;Y-hotspot
                dc.b SHP1x1 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 0;First left frame
                dc.b 6;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 24;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 45

        ;Actor 39 - weapon salesman in the desert

shape39:        dc.b 12;X-hotspot
                dc.b 39;Y-hotspot
                dc.b SHP1x2 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 0;First left frame
                dc.b 6;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 32;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 48,49

        ;Actor 40 - Sadok

shape40:        dc.b 12;X-hotspot
                dc.b 39;Y-hotspot
                dc.b SHP1x2 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 0;First left frame
                dc.b 6;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 32;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 40,41
                dc.b 42,41
                dc.b 43,41
                dc.b 44,41
                dc.b 44,45
                dc.b 44,46
                dc.b 44,47

        ;Actor 41 - Dr.Ultrashred (Mad Scientist)

shape41:        dc.b 24;X-hotspot
                dc.b 20;Y-hotspot
                dc.b SHP2x1 ;Sprite row configuration
                dc.b 0 ;Unused
                dc.b 0;First left frame
                dc.b 24;Horizontal size (from hotspot to left & right, symmetrically)
                dc.b 8;Vertical size from hotspot upwards
                dc.b 0 ;Vertical size from hotspot downwards

                dc.b 50,51
                dc.b 52,53

        ;Enemy-specific tables (starting from the first enemy, punk)

        ;Enemy default health
enemypower:     dc.b $02,$05,$06,$03
                dc.b $07,$06,$01,$02
                dc.b $03,$06,$08,$04
                dc.b $03,$01,$01,$01
                dc.b $01

        ;Score for killing the enemy
enemyscorelo:   dc.b $00,$00,$50,$50,$00,$00,$50,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
enemyscorehi:   dc.b $02,$05,$07,$04,$08,$09,$01,$02,$05,$09,$10,$08,$06,$00,$00,$00,$00

        ;Enemy's death actor type
enemydeathshp:  dc.b SHP_DBLEXPL,SHP_QUADEXPL,SHP_DBLEXPL,SHP_DBLEXPL
                dc.b SHP_DBLEXPL,SHP_EXPLOSION,SHP_EXPLOSION,SHP_EXPLOSION
                dc.b SHP_EXPLOSION,SHP_EXPLOSION,SHP_EXPLOSION,SHP_EXPLOSION
                dc.b SHP_EXPLOSION,SHP_BOSS0,SHP_BOSS1,SHP_BOSS2,SHP_BOSS3

        ;Enemy's death sound effect
enemydeathsfx:  dc.b SFX_EXPLOSION,SFX_EXPLOSION,SFX_EXPLOSION,SFX_EXPLOSION
                dc.b SFX_EXPLOSION,SFX_EXPLOSION,SFX_EXPLOSION,SFX_EXPLOSION
                dc.b SFX_EXPLOSION,SFX_EXPLOSION,SFX_EXPLOSION,SFX_EXPLOSION
                dc.b SFX_EXPLOSION,SFX_NONE,SFX_NONE,SFX_NONE,SFX_NONE

        ;Y-modification when enemy dies
enemydeathymod: dc.b 0,0,0,0
                dc.b 0,10,0,8
                dc.b 8,10,8,0
                dc.b 0,0,0,0,0

        ;Damage caused by touching the enemy
enemydamage:    dc.b 0,1,0,0
                dc.b 0,0,1,1
                dc.b 1,1,0,1
                dc.b 1,1,1,1,0

        ;X-modification to the bullet position
enemysmodx:     dc.b 12,0,12,12
                dc.b 12,8,0,0
                dc.b 0,0,0,0
                dc.b 16,52,0,30,18
        ;Y-modification to the bullet position
enemysmody:     dc.b 22,0,24,22
                dc.b 32,16,0,0
                dc.b 0,0,-2,0
                dc.b 0,30,0,30,17
        ;Enemy spawn mode
enemyspawn:     dc.b SPW_GROUND, SPW_GROUND, SPW_AIR, SPW_GROUND
                dc.b SPW_GROUND, SPW_GROUND, SPW_AIR, SPW_GROUND
                dc.b SPW_GROUND, SPW_GROUND, SPW_EXACT, SPW_AIR
                dc.b SPW_AIR,SPW_EXACT,SPW_EXACT,SPW_EXACT,SPW_EXACT

        ;Powerup table
powerupttbl:    dc.b ITEM_HEALTH
                dc.b ITEM_HEALTH
                dc.b ITEM_CREDITS
                dc.b ITEM_CREDITS
                dc.b ITEM_CREDITS
                dc.b ITEM_CREDITS
                dc.b ITEM_RIFLE
                dc.b ITEM_GRENADE

powerupptbl:    dc.b $01
                dc.b $01
                dc.b $02
                dc.b $05
                dc.b $07
                dc.b $10
                dc.b $20
                dc.b $03
                
        ;Tables for scrolling & background collision detection

rowhitbl:       dc.b 0,64,128,192
scradrtblhi:    dc.b >SCREEN1, >SCREEN2
shiftjumptbllo: dc.b <ds_shift1, <ds_shift2
shiftjumptblhi: dc.b >ds_shift1, >ds_shift2

        ;Tables & variables for reading the joystick & keyboard

colbit:         dc.b $01,$02,$04,$08,$10,$20,$40,$80
rowbit:         dc.b $fe,$fd,$fb,$f7,$ef,$df,$bf,$7f
rowval:         dc.b $00,$08,$10,$18,$20,$28,$30,$38
lastkey:        dc.b $00
keyval:         dc.b $00
keytemp:        dc.b $00
prevjoy:        dc.b $00
joystick:       dc.b $00

        ;Player variables

lastxl:         dc.b 0                  ;Last position at moment of death
lastxh:         dc.b 0
lastyl:         dc.b 0
lastyh:         dc.b 0
lastt:          dc.b 0
deadcnt:        dc.b 0                  ;Delay counter for being dead
level:          dc.b 0                  ;Level number
firedelay:      dc.b 0                  ;Fire delay counter
warp:           dc.b 0                  ;Warp indicator and target
warpdx:         dc.b 0
warpdy:         dc.b 0
warpdl:         dc.b 0
pausemode:      dc.b 0                  ;Pause indicator
itemnum:        dc.b 0                  ;Active item number

        ;Score, lives & some special variables

score:          dc.b 0,0,0,0
lives:          dc.b 0
drunk:          dc.b 0
drunkd:         dc.b 0
drunkrnd:       dc.b 0
murder:         dc.b 0
knowdetails:    dc.b 0
givecard:       dc.b 0
bossfight:      dc.b 0
bossdeath:      dc.b 0
deadbosstype:   dc.b 0
keycard1:       dc.b 0
keycard2:       dc.b 0
showcut4:       dc.b 0
episode:        dc.b 0

        ;Previous lives & health (for UPDATESCORE routine)

prevscore:      dc.b 255,255,255,255
prevpower:      dc.b 255

        ;Inventory item types (negative=empty)
plrinvt:        dc.b 128,128,128,128,128,128,128,128
        ;Inventory item power (ammo, credits)
plrinvp:        dc.b 0,0,0,0,0,0,0,0

        ;Weapon table
wpnaddxlo:      dc.b <10,<-10
wpnaddxhi:      dc.b >10,>-10
wpnaddy:        dc.b 20,12
wpnbltframe:    dc.b 0,0,3,2,4,1
wpndelay:       dc.b 12,6,15,10,4,6
wpnsx:          dc.b 6,8,3,8,6,10
wpnsy:          dc.b 0,0,-3,0,0,0
wpnsfx:         dc.b SFX_PISTOL,SFX_PISTOL,SFX_THROW,SFX_PLASMA,SFX_FLAME,SFX_LASER

        ;Weapon damage table
wpndamage:      dc.b 1,2,3,4,2,2,2,2

        ;Footstep sound table

walksndtbl:     dc.b 0,0,SFX_FOOTSTEP
                dc.b 0,0,SFX_FOOTSTEP

extracmp:       dc.b 0

        ;Enemy variables

bossexpf:       ds.b NBOSSEXP,0
bossexpfd:      ds.b NBOSSEXP,0
bossexpxl:      ds.b NBOSSEXP,0
bossexpyl:      ds.b NBOSSEXP,0
bossexpldelay:  dc.b 0
bossexplturn:   dc.b 0

bossxmod:       dc.b 8,4,8,4
bossxand:       dc.b 63,15,31,15
bossymod:       dc.b 3,3,4,0
bossyand:       dc.b 15,15,31,63

gunspd:         dc.b 6,0,-6,0
gunxlo:         dc.b 12,0,-12,0
gunxhi:         dc.b 0,0,255,0

crtbl:          dc.b 0,1,0,-1

b2sy:           dc.b 0
b2jd:           dc.b 0
b2spdtbl:       dc.b 0,-1,0,1


        ;Sound data

sfxlentbl:      dc.b $10,$18,$0a,$10,$0e,$08,$0c,$0a,$09,$1e,$08

sfxpritbl:      dc.b 1,1,1,2,3,3,3,3,3,4,1

sfxfreqtbl:     dc.b $80,$00,$00 ;FOOTSTEP
                dc.b $05,$10,$00 ;JUMP
                dc.b $13,$10,$00 ;SELECT
                dc.b $30,$00,$00 ;THROW
                dc.b $03,$07,$00 ;FLAME
                dc.b $80,$10,$f0 ;PISTOL
                dc.b $2c,$10,$00 ;PLASMA
                dc.b $40,$48,$00 ;LASER
                dc.b $07,$24,$22 ;HIT
                dc.b $00,$05,$0a ;EXPLOSION
                dc.b $02,$05,$00 ;TANK

sfxwavetbl:     dc.b $81,$00,$00 ;FOOTSTEP
                dc.b $41,$41,$00 ;JUMP
                dc.b $41,$21,$00 ;SELECT
                dc.b $11,$00,$00 ;THROW
                dc.b $21,$21,$00 ;FLAME
                dc.b $81,$41,$81 ;PISTOL
                dc.b $21,$41,$00 ;PLASMA
                dc.b $51,$41,$00 ;LASER
                dc.b $11,$15,$43 ;HIT
                dc.b $81,$81,$81 ;EXPLOSION
                dc.b $51,$51,$00 ;TANK

sfxgatetimetbl: dc.b $04,$00,$00 ;FOOTSTEP
                dc.b $10,$10,$00 ;JUMP
                dc.b $03,$03,$00 ;SELECT
                dc.b $0c,$00,$00 ;THROW
                dc.b $08,$07,$00 ;FLAME
                dc.b $02,$04,$02 ;PISTOL
                dc.b $0a,$0c,$00 ;PLASMA
                dc.b $08,$06,$00 ;LASER
                dc.b $06,$04,$05 ;HIT
                dc.b $06,$06,$06 ;EXPLOSION
                dc.b $03,$03,$00 ;TANK

sfxadtbl:       dc.b $13,$00,$00 ;FOOTSTEP
                dc.b $08,$07,$00 ;JUMP
                dc.b $13,$13,$00 ;SELECT
                dc.b $28,$00,$00 ;THROW
                dc.b $38,$38,$00 ;FLAME
                dc.b $08,$04,$04 ;PISTOL
                dc.b $18,$16,$00 ;PLASMA
                dc.b $27,$26,$00 ;LASER
                dc.b $34,$14,$15 ;HIT
                dc.b $08,$07,$06 ;EXPLOSION
                dc.b $07,$17,$00 ;TANK

sfxsrtbl:       dc.b $49,$00,$00 ;FOOTSTEP
                dc.b $67,$47,$00 ;JUMP
                dc.b $67,$57,$00 ;SELECT
                dc.b $45,$00,$00 ;THROW
                dc.b $98,$78,$00 ;FLAME
                dc.b $e9,$98,$88 ;PISTOL
                dc.b $96,$86,$00 ;PLASMA
                dc.b $77,$77,$00 ;LASER
                dc.b $87,$d8,$45 ;HIT
                dc.b $da,$d9,$d9 ;EXPLOSION
                dc.b $99,$a8,$00 ;TANK

sfxplshitbl:    dc.b $00,$00,$00 ;FOOTSTEP
                dc.b $03,$01,$00 ;JUMP
                dc.b $02,$00,$00 ;SELECT
                dc.b $00,$00,$00 ;THROW
                dc.b $00,$00,$00 ;FLAME
                dc.b $00,$08,$00 ;PISTOL
                dc.b $06,$08,$00 ;PLASMA
                dc.b $06,$04,$00 ;LASER
                dc.b $00,$00,$08 ;HIT
                dc.b $00,$00,$00 ;EXPLOSION
                dc.b $08,$06,$00 ;TANK

sfxadd1tbl:     dc.b $01,$00,$00 ;FOOTSTEP
                dc.b $01,$02,$00 ;JUMP
                dc.b $0a,$04,$00 ;SELECT
                dc.b $ff,$00,$00 ;THROW
                dc.b $01,$01,$00 ;FLAME
                dc.b $fc,$ff,$fc ;PISTOL
                dc.b $fd,$ff,$00 ;PLASMA
                dc.b $fe,$fd,$00 ;LASER
                dc.b $01,$fe,$ff ;HIT
                dc.b $01,$01,$02 ;EXPLOSION
                dc.b $08,$08,$00 ;TANK

sfxtime1tbl:    dc.b $02,$00,$00 ;FOOTSTEP
                dc.b $30,$02,$00 ;JUMP
                dc.b $03,$03,$00 ;SELECT
                dc.b $30,$00,$00 ;THROW
                dc.b $03,$03,$00 ;FLAME
                dc.b $30,$30,$30 ;PISTOL
                dc.b $0c,$0c,$00 ;PLASMA
                dc.b $30,$30,$00 ;LASER
                dc.b $30,$30,$30 ;HIT
                dc.b $04,$03,$02 ;EXPLOSION
                dc.b $01,$01,$00 ;TANK

sfxadd2tbl:     dc.b $fe,$00,$00 ;FOOTSTEP
                dc.b $00,$ff,$00 ;JUMP
                dc.b $f6,$fc,$00 ;SELECT
                dc.b $00,$00,$00 ;THROW
                dc.b $ff,$ff,$00 ;FLAME
                dc.b $00,$00,$00 ;PISTOL
                dc.b $01,$01,$00 ;PLASMA
                dc.b $00,$00,$00 ;LASER
                dc.b $00,$00,$00 ;HIT
                dc.b $ff,$ff,$ff ;EXPLOSION
                dc.b $f8,$f8,$00 ;TANK

sfxtime2tbl:    dc.b $02,$00,$00 ;FOOTSTEP
                dc.b $30,$02,$00 ;JUMP
                dc.b $03,$03,$00 ;SELECT
                dc.b $00,$00,$00 ;THROW
                dc.b $03,$03,$00 ;FLAME
                dc.b $00,$00,$00 ;PISTOL
                dc.b $10,$10,$00 ;PLASMA
                dc.b $00,$00,$00 ;LASER
                dc.b $00,$00,$00 ;HIT
                dc.b $03,$02,$03 ;EXPLOSION
                dc.b $01,$01,$00 ;TANK

chfreqhi:       dc.b 0,0,0
chwave:         dc.b 0,0,0
chad:           dc.b 0,0,0
chsr:           dc.b 0,0,0
chgatetime:     dc.b 0,0,0
chfreqtime:     dc.b 0,0,0
chfreqdir:      dc.b 0,0,0
chsndnum:       dc.b 0,0,0
chregnum:       dc.b 0,7,14

sfxlen:         dc.b 0
sfxpri:         dc.b 0
sfxmode:        dc.b 0
lastgametune:   dc.b MUS_STOP

        ;Loaded level number
loadedlevel:    dc.b LVL_TITLE

        ;Colors and music of levels
lvlcoltbl1:     dc.b $01,$0f,$0c,$0f,$08,$0e,$0f,$0f
lvlcoltbl2:     dc.b $0b,$0e,$0b,$09,$09,$06,$0c,$0b
lvlbgtbl:       dc.b $00,$06,$00,$00,$00,$00,$09,$00
lvltune:        dc.b MUS_TITLE,MUS_CITY,MUS_INSIDE,MUS_FOREST,MUS_CAVERN,MUS_BASE,MUS_CITY,MUS_BASE

        ;Cutscene data

cutscenetune:   dc.b MUS_CUTSCENE,MUS_CUTSCENE,MUS_CUTSCENE
                dc.b MUS_CUTSCENE,MUS_CUTSCENE,MUS_VICTORY

sprwritextbllo: dc.b 0,1,2
                dc.b 64,65,66
                dc.b 128,129,130
                dc.b 192,193,194
                dc.b 0,1,2
                dc.b 64,65,66
                dc.b 128,129,130
                dc.b 192,193,194

sprwritextblhi: dc.b 0,0,0,0,0,0,0,0,0,0,0,0
                dc.b 1,1,1,1,1,1,1,1,1,1,1,1

sprwriteytblhi: dc.b >(BOSS),>(BOSS+512),>(BOSS+1024)


cuts_sprxtbl:   dc.b 88,112,136,160,184,208,232,0
cuts_sprxhtbl:  dc.b 0,0,0,0,0,0,0,1
cuts_hcdx:      dc.b 0
cuts_hcdx2:     dc.b 0
cuts_hcdy:      dc.b 0
cuts_hcc:       dc.b 0
cuts_hcydec:    dc.b 0
cuts_hcxdec:    dc.b 0
cuts_hcd:       dc.b 0
cuts_hcctbl:    dc.b 8,8,7,7
cuts_charpos:   dc.b 0
cuts_chardelay: dc.b 0

cuts_sprite:    incbin hovercar.spr

        ;Scorepanel color datas

panelcolors:    ds.b 40,9
                dc.b 9,0,0,9,0,0,9,0,0,9,0,0,9,0,0,9,0,0,9,0,0,9,0,0,9,9,9,15,15,9,9,1,1,1,1,1,1,1,1,9
                dc.b 9,0,0,9,0,0,9,0,0,9,0,0,9,0,0,9,0,0,9,0,0,9,0,0,9,9,9,15,15,9,9,9,9,9,9,9,9,9,9,9
                dc.b 9,1,1,9,1,1,9,1,1,9,1,1,9,1,1,9,1,1,9,1,1,9,1,1,9,9,9,1,1,9,9,10,10,13,13,13,13,13,13,9
                ds.b 40,9

        ;Titlescreen variables

tcoldelay:      dc.b 0
tcolcnt:        dc.b 0
tcoltbl1:       dc.b 0,11,12,13,1,13,12,11
tcoltbl2:       dc.b 6,11,14,15,1,15,14,11,6
ttbllo:         dc.b <printtitle, <printhiscore, <printinstr, <printstory
ttblhi:         dc.b >printtitle, >printhiscore, >printinstr, >printstory
titlemode:      dc.b 0
titletimelo:    dc.b 0
titletimehi:    dc.b 0
cheatletter:    dc.b 0
cframe:         dc.b 0
crow:           dc.b 0

cheatstring:    dc.b KEY_B, KEY_O, KEY_F, KEY_H

        ;Communication variables, data & texts
        
moneyidx:       dc.b 0
shopitemnum:    dc.b 0
keywordnum:     dc.b 0
actorkeytbl:    ds.b MAX_ACTOR*16,0

talktotxt:      dc.b "TALK TO",0
abouttxt:       dc.b "ABOUT",0
costtext:       dc.b "COST 00 CREDITS",0
roundtext:      dc.b "- 00 ROUNDS",0

actornametbl:   dc.w actorn0
                dc.w actorn1
                dc.w actorn2
                dc.w actorn3
                dc.w actorn4

nokeytxt:       dc.b "NOTHING TO TALK ABOUT!",0

actorn0:        dc.b "FAUSTUS",0
actorn1:        dc.b "GOAT",0
actorn2:        dc.b "PHANTASM",0
actorn3:        dc.b "DETHMASTER",0
actorn4:        dc.b "DETECTIVE HAMMER",0

keywordtbl:     dc.w keyword0
                dc.w keyword1
                dc.w keyword2
                dc.w keyword3
                dc.w keyword4
                dc.w keyword5
                dc.w keyword6
                dc.w keyword7
                dc.w keyword8

keyword0:       dc.b "SADOK",0
keyword1:       dc.b "HITMEN",0
keyword2:       dc.b "JOINING",0
keyword3:       dc.b "ATTACK",0
keyword4:       dc.b "CAVES",0
keyword5:       dc.b "FIENDISH PLOT",0
keyword6:       dc.b "WHAT'S HAPPENED?",0
keyword7:       dc.b "ABDUCTION",0
keyword8:       dc.b "EVIDENCE",0

actortbl:       dc.w fa_table
                dc.w go_table
                dc.w ph_table
                dc.w dm_table
                dc.w dh_table
                dc.w musshop_table
                dc.w gunshop_table
                dc.w bar_table
                dc.w nukeman_table

fa_table:       dc.w fa_sadok
                dc.w fa_hitmen
                dc.w fa_join
                dc.w fa_murder
                dc.w fa_caves
                dc.w fa_plot
                dc.w fa_what
                dc.w fa_abd
                dc.w fa_evd

fa_sadoktxt:    dc.b "SADOK WAS A TOTAL ASSHOLE, BUT",0
                dc.b "NO-ONE DESERVES A DEATH LIKE",0
                dc.b "THAT! THE BIG HOLE IN HIS CHEST",0
                dc.b "WAS MOST LIKELY CAUSED BY A",0
                dc.b "PLASMA RIFLE. HITMEN USE THEM.",0,$ff
fa_hitmentxt:   dc.b "ASK GOAT, HE LIKES TO HANG OUT",0
                dc.b "WITH THOSE GUYS.",0,$ff
fa_jointxt1:    dc.b "WE HAVE FAST SONGS, IT'LL BE A",0
                dc.b "CHALLENGE FOR YOU. WHEN YOU",0
                dc.b "HAVE AN AXE, COME BACK HERE!",0,$ff
fa_jointxt2:    dc.b "YOU'VE DECIDED TO TRY IT OUT?",0
                dc.b "OK, I'LL SUMMON THE OTHERS AND",0
                dc.b "WE'LL JAM SOMETHING.",0,$ff
fa_murdertxt:   dc.b "YOU WERE ATTACKED? HOLY SHIT,",0
                dc.b "SOMETHING BIG MUST BE GOING ON.",0
                dc.b "IT SEEMS, WE ALL ARE IN DANGER.",0,$ff
fa_cavestxt:    dc.b "YOU SHOULD BUY SOME SERIOUS",0
                dc.b "ARMAMENT BEFORE GOING THERE.",0
                dc.b "I HAVE HEARD THAT THE PLACE IS",0
                dc.b "FULL OF HUNGRY MUTANTS.",0,$ff
fa_plottxt:     dc.b "I CAN ONLY GUESS WHAT IT'S ALL",0
                dc.b "ABOUT. SADOK SHOULD HAVE SOME",0
                dc.b "HARD DATA.",0,$ff
fa_whattxt:     dc.b "PHANTASM IS MISSING. IT SEEMS,",0
                dc.b "THAT THE MOST SKILLFUL PLAYERS",0
                dc.b "IN THIS AREA GET ABDUCTED, BUT",0
                dc.b "FOR WHAT PURPOSE?",0,$ff
fa_abdtxt:      dc.b "SO SHE IS HELD IN A SECRET LAB",0
                dc.b "TO RECORD A DOOMSDAY SYMPHONY?",0
                dc.b "THAT SOUNDS LIKE A FUCKIN'",0
                dc.b "B-MOVIE...I JUST HOPE YOU'RE",0
                dc.b "RIGHT.",0,$ff
fa_evdtxt:      dc.b "YOU EVEN GOT EVIDENCE? WELL,",0
                dc.b "THEN WASTE NO MORE TIME. GO SEE",0
                dc.b "THE DETECTIVE SADOK TOLD ABOUT!",0,$ff

go_table:       dc.w go_sadok
                dc.w go_hitmen
                dc.w go_join
                dc.w go_murder
                dc.w go_caves
                dc.w go_plot
                dc.w fa_what
                dc.w go_abd
                dc.w go_evd

go_sadoktxt:    dc.b "HE WAS A WEAKLING, THEY TEND TO",0
                dc.b "DIE EARLY. SEE THIS BOOK I'M",0
                dc.b "READING? IT'S ABOUT THE RISE OF",0
                dc.b "OVER-MAN, HE WILL TRIUMPH OVER",0
                dc.b "THE WEAKLINGS. I'M ON THE WAY",0
                dc.b "OF BECOMING AN OVER-MAN!",0,$ff
go_hitmentxt:   dc.b "I DOUBT THEY WERE INVOLVED IN",0
                dc.b "THE KILLING, BUT YOU CAN ASK",0
                dc.b "DETHMASTER. HE'S A RETIRED",0
                dc.b "KILLER, YOU'LL FIND HIM IN THE",0
                dc.b "BAR.",0,$ff
go_jointxt:     dc.b "HMM...I HOPE YOU'RE NOT AS WEAK",0
                dc.b "AS SADOK. I WOULD LIKE A REAL",0
                dc.b "OVER-MAN IN THE BAND.",0,$ff
go_murdertxt:   dc.b "YOU SURVIVED THE ATTACK, THAT",0
                dc.b "SHOWS YOU ARE NOT WEAK. YOU",0
                dc.b "HAVE EARNED MY RESPECT!",0,$ff
go_cavestxt:    dc.b "DON'T WASTE ANY MORE TIME. GO",0
                dc.b "THERE LIKE AN OVER-MAN!",0,$ff
go_plottxt:     dc.b "IT MUST HAVE SOMETHING TO DO",0
                dc.b "WITH THE MILITARY!",0,$ff
go_abdtxt:      dc.b "CALM DOWN, TRUE OVER-MEN CAN",0
                dc.b "CONTROL THEIR EMOTIONS. DON'T",0
                dc.b "LET THIS CLOUD YOUR JUDGEMENT.",0,$ff
go_evdtxt:      dc.b "HMM...STILL I CANNOT COMPLETELY",0
                dc.b "TRUST EVIDENCE PROVIDED BY THAT",0
                dc.b "WEAKLING...BUT THERE SEEMS TO",0
                dc.b "BE NO CHOICE.",0,$ff

ph_table:       dc.w ph_sadok
                dc.w ph_hitmen
                dc.w ph_join
                dc.w ph_murder
                dc.w ph_caves
                dc.w ph_plot

ph_sadoktxt:    dc.b "I NEVER GOT ALONG WITH HIM, BUT",0
                dc.b "HIS DEATH WAS SHOCKING. YET WE",0
                dc.b "HAVE TO GO ON, WE'RE LOOKING",0
                dc.b "FOR A NEW GUITARIST TO JOIN.",0,$ff
ph_hitmentxt:   dc.b "DON'T ASK ME, I'M JUST A",0
                dc.b "MUSICIAN!",0,$ff
ph_jointxt:     dc.b "SADOK TOLD YOU'RE QUITE A GOOD",0
                dc.b "PLAYER. COME WITH YOUR AXE TO",0
                dc.b "OUR REHEARSAL ROOM TO TRY IT.",0,$ff
ph_murdertxt:   dc.b "HUH, I'M GLAD YOU SURVIVED. WHO",0
                dc.b "ARE THESE MURDERERS, AND WHY DO",0
                dc.b "THEY ATTACK INNOCENT MUSICIANS?",0
                dc.b "IT'S CRAZY, ANYONE CAN BE THE",0
                dc.b "NEXT VICTIM!",0,$ff
ph_cavestxt:    dc.b "AND AGAIN YOU GO TO RISK YOUR",0
                dc.b "LIFE. I KNOW IT'S UNAVOIDABLE..",0
                dc.b "BUT BE CAREFUL!",0,$ff
ph_plottxt:     dc.b "MUST BE QUITE A CONSPIRACY. SO",0
                dc.b "MANY HAVE DIED ALREADY! WHAT",0
                dc.b "ARE THEY COVERING UP?",0,$ff
                
dm_table:       dc.w 0
                dc.w dm_hitmen
                dc.w 0
                dc.w dm_murder
                
dm_hitmentxt:   dc.b "..GLUG GLUG..THERE'S MORE THAN",0
                dc.b "50 DIFFERENT HITMAN-TEAMS HERE",0
                dc.b "IN SUB-CITY. I CAN'T HELP YOU",0
                dc.b "UNLESS YOU CAN PROVIDE DETAILS.",0,$ff
dm_burptxt:     dc.b "..BURP..I WON'T TELL ANYTHING!",0,$ff
dm_murdertxt:   dc.b "..GLUG GLUG..SO THE ATTACKERS",0
                dc.b "WERE USING JETPACKS? AND WHAT?",0
                dc.b "HAVE KILLED MANY MUSICIANS?",0
                dc.b "THAT MAKES ME ANGRY! I WILL",0
                dc.b "HELP YOU TO GET YOUR REVENGE.",0
                dc.b "THE GROUP IN QUESTION HAS TO",0
                dc.b "BE 'DEATH WINGS'. THEIR HIDEOUT",0
                dc.b "IS JUST OUTSIDE THE CITY, IN",0
                dc.b "THE ABANDONED SEWER. USE THIS",0
                dc.b "KEYCARD TO GET IN.",0,$ff
dm_getlosttxt:  dc.b "I GAVE YOU THE KEYCARD, NOW GET",0
                dc.b "LOST. AND REMEMBER, YOU NEVER",0
                dc.b "MET ME!",0,$ff
                
dh_table:       dc.w dh_sadok
                dc.w 0
                dc.w 0
                dc.w dh_murder
                dc.w 0
                dc.w dh_plot
                dc.w 0
                dc.w 0
                dc.w dh_evd
                
dh_sadoktxt:    dc.b "I'M SORRY FOR WHAT HAPPENED TO",0
                dc.b "YOUR FRIEND, BUT WE DON'T HAVE",0
                dc.b "THE RESOURCES TO INVESTIGATE",0
                dc.b "EVERY GANG KILLING.",0,$ff
dh_murdertxt:   dc.b "I RECOMMEND THAT YOU INVEST IN",0
                dc.b "MORE FIREPOWER. IT'S PERFECTLY",0
                dc.b "LEGAL IN THIS CITY.",0,$ff
dh_plottxt:     dc.b "YOU SUGGEST CONSPIRACY BEHIND",0
                dc.b "THE DEATH OF A FEW MUSICIANS?",0
                dc.b "WITHOUT ANY EVIDENCE, WE CAN",0
                dc.b "NOT INVESTIGATE.",0,$ff
dh_evdtxt:      dc.b "HMM, A FLOPPY DISK. LET ME SEE.",0
                dc.b " ",0
                dc.b " ",0
                dc.b "...A DEAL WITH A CRIMINALLY",0
                dc.b "INSANE SCIENTIST, A DEAL WITH",0
                dc.b "HITMEN... THIS IS SOME HARD",0
                dc.b "EVIDENCE! THE MILITARY BASTARDS",0
                dc.b "WILL BE IN DEEP SHIT. BUT THE",0
                dc.b "PROSECUTION WILL TAKE SOME TIME",0
                dc.b "WHICH WE DON'T HAVE. SO I GIVE",0
                dc.b "YOU THE KEYCARD TO ACCESS THE",0
                dc.b "RESTRICTED AREA EAST OF THE",0
                dc.b "CITY. YOU ALSO HAVE ACCESS TO",0
                dc.b "THE ARMORY.",0,$ff
dh_evdtxt2:     dc.b "NOW, GET GOING!",0,$ff

        ;Shop tables

musshop_table:  dc.b ITEM_GUITAR, $20, $01
                dc.b $ff,0,0
                dc.b $ff,0,0
                dc.b $ff,0,0
                dc.b $ff,0,0
                dc.b $ff,0,0
                dc.b $ff,0,0
                dc.b $ff,0,0

gunshop_table:  dc.b ITEM_HEALTH, $10, $01
                dc.b ITEM_RIFLE, $15, $30
                dc.b ITEM_FLAME, $20, $30
                dc.b ITEM_LASER, $30, $30
                dc.b ITEM_GRENADE, $35, $10
                dc.b ITEM_PLASMA, $40, $30
                dc.b $ff,0,0
                dc.b $ff,0,0
                dc.b $ff,0,0

bar_table:      dc.b ITEM_BEER, $03, $01
                dc.b $ff,0,0
                dc.b $ff,0,0
                dc.b $ff,0,0
                dc.b $ff,0,0
                dc.b $ff,0,0
                dc.b $ff,0,0
                dc.b $ff,0,0

nukeman_table:  dc.b ITEM_HEALTH, $05, $01
                dc.b ITEM_RIFLE, $10, $30
                dc.b ITEM_FLAME, $15, $30
                dc.b ITEM_LASER, $20, $30
                dc.b ITEM_GRENADE, $25, $10
                dc.b ITEM_PLASMA, $30, $30
                dc.b $ff,0,0
                dc.b $ff,0,0
                dc.b $ff,0,0
                
        ;Scrolling messages

msgptr:         dc.w msg0
                dc.w msg1
                dc.w msg2
                dc.w msg3
                dc.w msg4
                dc.w msg5
                dc.w msg6
                dc.w msg7
                dc.w msg8
                dc.w msg9
                dc.w msg10
                dc.w msg11
                dc.w msg12
                dc.w msg13
                dc.w msg14
                dc.w msg15
                dc.w msg16
                dc.w msg17
                dc.w msg18
                dc.w msg19
                dc.w msg20
                dc.w msg21
                dc.w msg22
                dc.w msg23
                dc.w msg24
                dc.w msg25
                dc.w msg26
                dc.w msg27
                dc.w msg28
                dc.w msg29
                dc.w msg30
                dc.w msg31


MSG_MUSICON     = 0
msg0:           dc.b "MUSIC ON",0
MSG_SFXON       = 1
msg1:           dc.b "SOUND FX ON",0
MSG_PAUSE1      = 2
msg2:           dc.b "GAME RESUMED",0
MSG_PAUSE2      = 3
msg3:           dc.b "GAME PAUSED",0
MSG_ERROR       = 24
msg24:          dc.b "DISK ERROR - PRESS FIRE TO RETRY!",0
MSG_NOMONEY     = 19
msg19:          dc.b "NOT ENOUGH CREDITS!",0
MSG_NOROOM      = 20
msg20:          dc.b "NO ROOM IN INVENTORY!",0
MSG_FULLAMMO    = 21
msg21:          dc.b "ALREADY FULL AMMO!",0
MSG_BOUGHT      = 22
msg22:          dc.b "BOUGHT!",0
MSG_KEYCARD     = 25
msg25:          dc.b "KEYCARD REQUIRED!",0
MSG_BONUS1      = 28
msg28:          dc.b "GAME COMPLETE BONUS",0
MSG_BONUS2      = 29
msg29:          dc.b "LIVES REMAINING BONUS",0
MSG_BONUS3      = 30
msg30:          dc.b "ENERGY REMAINING BONUS",0
MSG_BONUS4      = 31
msg31:          dc.b "WEAPONS REMAINING BONUS",0
MSG_ITEM1       = 4

msg4:           dc.b "PISTOL",0
msg5:           dc.b "ASSAULT RIFLE",0
msg6:           dc.b "GRENADES",0
msg7:           dc.b "PLASMA GUN",0
msg8:           dc.b "FLAME THROWER",0
msg9:           dc.b "LASER",0
msg10:          dc.b "FIRST AID",0
msg11:          dc.b "CREDITS",0
msg12:          dc.b "GUITAR",0
msg13:          dc.b "KEYCARD 1",0
msg14:          dc.b "KEYCARD 2",0
msg15:          dc.b "EVIDENCE DISK",0
msg16:          dc.b "BEER",0
MSG_THOUGHT1    = 17
msg17:          dc.b "'SO BEGINS MY QUEST...'",0
MSG_THOUGHT2    = 18
msg18:          dc.b "'AXE? FUCK, I SOLD IT SO I COULD BOOZE!'",0
MSG_HITMEN      = 23
msg23:          dc.b "'FUCK! ATTACK OF THE HITMEN!'",0
MSG_SADOK       = 26
msg26:          dc.b "'SADOK! GOOD TO SEE YOU!'",0
MSG_KNOW        = 27
msg27:          dc.b "'I THINK I KNOW WHY, AND WHERE SHE IS.'",0

        ;Titlescreen texts

ttext1:         dc.b "A COVERT BITOPS PRODUCTION - V1.6",0
                dc.b "CODE, GFX AND SOUND BY CADAVER",0
                dc.b "EXOMIZER BY MAGNUS LIND",0
                dc.b "LOADER BY NINJA,DOCBACARDI,MAGERVALP",0
                dc.b "PRESS FIRE TO START",0
ttext5:         dc.b "TOP 10 HEADBANGERS",0
ttext6:         dc.b "PROLOGUE",0
                dc.b "IT'S YEAR 2010. TAKE  THE ROLE OF IAN,",0
                dc.b "A YOUNG METAL GUITARIST. CHALLENGE THE",0
                dc.b "BLOODTHIRSTY VILLAINS  AND RADIOACTIVE",0
                dc.b "MUTANTS AS A SINISTER PLOT AGAINST THE",0
                dc.b "WORLD  SLOWLY UNVEILS.  STAY ALERT AND",0
                dc.b "KEEP YOUR GUN READY TO SURVIVE IN THIS",0
                dc.b "DISMAL FUTURE WORLD.                  ",0

ttext7:         dc.b "JOYSTICK2 AND KEY CONTROLS",0
                dc.b "UP    JUMP/CLIMB/ENTER",0
                dc.b "DOWN  DUCK/CLIMB/PICK ",0
                dc.b "LEFT  MOVE/TURN LEFT  ",0
                dc.b "RIGHT MOVE/TURN RIGHT ",0
                dc.b "FIRE  USE WEAPON      ",0
                dc.b "SPACE COMMUNICATE     ",0
                dc.b ",.    SELECT WEAPON   ",0
                dc.b "R/S   PAUSE GAME      ",0
                dc.b "S     TOGGLE MUSIC/SFX",0
                dc.b "Q     QUIT PAUSED GAME",0

htext1:         dc.b "YOU ARE A TRUE METAL WARRIOR",0
                dc.b "ENTER YOUR NAME USING KEYBOARD",0

        ;Ascii for keycodes

asciitable:     dc.b 255,13,"      "
                dc.b "3WA4ZSE "
                dc.b "5RD6CFTX"
                dc.b "7YG8BHUV"
                dc.b "9IJ0MKON"
                dc.b " PL-. @,"
                dc.b "       /"
                dc.b "1  2  Q "

        ;Hiscore order

hsnumber1:      dc.b "         1"
hsnumber2:      dc.b "1234567890"


