        ;Sprite multicolors

SPRMC1          = $0a
SPRMC2          = $00

        ;Amount of sprites & actors

MAX_SHP         = 15
MAX_SPR         = 24
MAX_SPRIRQ      = 16
NUM_SPRROWS     = 20
NUM_LVLSHP      = 64  ;Must not be changed (leveldata must take 256 bytes/level)
MAX_ACTOR       = 5

        ;Actor types
SHP_OFF         = 0
SHP_PLRRUN      = 1
SHP_PLRDUCK     = 2
SHP_PLRCLIMB    = 3
SHP_PLRDEAD     = 4
SHP_ITEM        = 5
SHP_BULLET      = 6
SHP_EXPLOSION   = 7
SHP_SHRAPNEL    = 8
SHP_BLOOD       = 9
SHP_DBLEXPL     = 10
SHP_QUADEXPL    = 11
SHP_PUNK        = 12
SHP_MOTORIST    = 13
SHP_JETPACK     = 14
SHP_TERRORIST   = 15
SHP_CYBERGOAT   = 16
SHP_ROBOGOAT    = 17
SHP_BAT         = 18
SHP_RAT         = 19
SHP_SLIME       = 20
SHP_PIG         = 21
SHP_GUN         = 22
SHP_DROID       = 23
SHP_CRAFT       = 24
SHP_BOSS0       = 25
SHP_BOSS1       = 26
SHP_BOSS2       = 27
SHP_BOSS3       = 28
SHP_BLAST       = 29
SHP_VISITSIGN   = 30
SHP_FAUSTUS     = 31
SHP_GOAT        = 32
SHP_PHANTASM    = 33
SHP_DETHMASTER  = 34
SHP_HAMMER      = 35
SHP_MUSICSHOP   = 36
SHP_GUNSHOP     = 37
SHP_BARTENDER   = 38
SHP_NUKEMAN     = 39
SHP_SADOK       = 40
SHP_SCIENTIST   = 41

        ;Item-numbers with 128 added (in leveldata)
SHP_PISTOL     = 128
SHP_RIFLE      = 129
SHP_GRENADE    = 130
SHP_PLASMA     = 131
SHP_FLAME      = 132
SHP_LASER      = 133
SHP_HEALTH     = 134
SHP_CREDITS    = 135
SHP_GUITAR     = 136
SHP_KEYCARD1   = 137
SHP_KEYCARD2   = 138
SHP_EVIDENCE   = 139
SHP_BEER       = 140

        ;Actual item numbers
ITEM_PISTOL     = 0
ITEM_RIFLE      = 1
ITEM_GRENADE    = 2
ITEM_PLASMA     = 3
ITEM_FLAME      = 4
ITEM_LASER      = 5
ITEM_HEALTH     = 6
ITEM_CREDITS    = 7
ITEM_GUITAR     = 8
ITEM_KEYCARD1   = 9
ITEM_KEYCARD2   = 10
ITEM_EVIDENCE   = 11
ITEM_BEER       = 12
IT              = 128

MAX_MEDIKITS    = $10

        ;Sprite formation types for transforming actors into sprites
SHP1x1          = 0
SHP1x2          = 1
SHP2x1          = 2
SHP2x2          = 3
SHP4x2          = 4
SHP3x3          = 5
SHP2x4          = 6
SHP2x2B         = 7

        ;First and last enemy actor
FENEMYTYPE      = SHP_PUNK
LENEMYTYPE      = SHP_BOSS3

        ;First and last intelligent (can be communicated with) NPC
FCHARACTER      = SHP_FAUSTUS
LCHARACTER      = SHP_NUKEMAN

        ;Indexes in actortable
PLAYER          = 0
FIRSTNPC        = 1
LASTNPC         = 8
PWRUP           = 9
FIRSTENMBLT     = 10
LASTENMBLT      = 11
FIRSTPLRBLT     = 12
LASTPLRBLT      = 14

        ;Amount of different levels
NUM_LEVELS      = 7

        ;Defines for background bits
CI_WALK         = 1
CI_OBSTACLE     = 2
CI_CLIMB        = 4
CI_DOOR         = 8

        ;Amount of scrolling rows
ROWS            = 18

        ;Screen modes
SCRM_BLANK      = 0
SCRM_GAME       = 1
SCRM_TITLE      = 2

        ;Level numbers
LVL_TITLE       = 0
LVL_CITY        = 1
LVL_INSIDE      = 2
LVL_FOREST      = 3
LVL_CAVERN      = 4
LVL_BASE        = 5
LVL_DESERT      = 6
LVL_FINAL       = 7

        ;Spawn modes for enemies
SPW_EXACT       = 2
SPW_GROUND      = 1
SPW_AIR         = 0

        ;Cutscene commands
CSHOWPIC        = 0
CHIDEPIC        = 1
CTEXT           = 2
CCLRSCR         = 3
CDELAY          = 4
CEND            = 5
CBIGPIC         = 6

        ;Player maximum health
PLR_MAXPOWER    = 32

        ;Joystick & keyboard defines
JOY_UP          = 1
JOY_DOWN        = 2
JOY_LEFT        = 4
JOY_RIGHT       = 8
JOY_FIRE        = 16

KEY_DEL         = 0
KEY_CR          = 1
KEY_CURSLR      = 2
KEY_F7          = 3
KEY_F1          = 4
KEY_F3          = 5
KEY_F5          = 6
KEY_CURSUD      = 7
KEY_3           = 8
KEY_W           = 9
KEY_A           = 10
KEY_4           = 11
KEY_Z           = 12
KEY_S           = 13
KEY_E           = 14
KEY_SHIFT1      = 15
KEY_5           = 16
KEY_R           = 17
KEY_D           = 18
KEY_6           = 19
KEY_C           = 20
KEY_F           = 21
KEY_T           = 22
KEY_X           = 23
KEY_7           = 24
KEY_Y           = 25
KEY_G           = 26
KEY_8           = 27
KEY_B           = 28
KEY_H           = 29
KEY_U           = 30
KEY_V           = 31
KEY_9           = 32
KEY_I           = 33
KEY_J           = 34
KEY_0           = 35
KEY_M           = 36
KEY_K           = 37
KEY_O           = 38
KEY_N           = 39
KEY_PLUS        = 40
KEY_P           = 41
KEY_L           = 42
KEY_MINUS       = 43
KEY_PISTE       = 44
KEY_2PISTE      = 45
KEY_MIUMAU      = 46
KEY_PILKKU      = 47
KEY_PUNTA       = 48
KEY_TAHTI       = 49
KEY_PUOLIPISTE  = 50
KEY_HOME        = 51
KEY_SHIFT2      = 52
KEY_ON          = 53
KEY_ARROWU      = 54
KEY_SLASH       = 55
KEY_1           = 56
KEY_ARROWL      = 57
KEY_CTRL        = 58
KEY_2           = 59
KEY_SPACE       = 60
KEY_CBM         = 61
KEY_Q           = 62
KEY_RUNSTOP     = 63

        ;Zeropage memory locations (note: they overlap for some routines)
        ;Collision detection

shpnum1         = $03
shpnum2         = $04
shpadrlo1       = $05
shpadrhi1       = $06
shpadrlo2       = $07
shpadrhi2       = $08

        ;Updatesprites routine + scrolling tempregs

numspr          = $02
tempshpxl       = $03
maptemplo       = $03
tempshpxh       = $04
maptemphi       = $04
tempshpyl       = $05
scrolltemp1     = $05
tempshpyh       = $06
tempd010        = $06
scrolltemp2     = $06
scrolltemp3     = $07
scrolltemp4     = $08
sprsprstart     = $09
sprsprend       = $0a
sprirqfirst     = $0b
sprirqlast      = $0c
sprfirst        = $0d
sprlast         = $0e
sortorder       = $0f

        ;Message routine
        
msglo           = $28
msghi           = $29

        ;16-bit "accumulator" for calculations

alo             = $2a
ahi             = $2b

        ;Conversation & shop-routines

actornum        = $2c
selitem         = $2d
selitemcost     = $2e
selitempower    = $2f

        ;Updateshapes routine

sptrlo          = $31
sptrhi          = $32
shpindex        = $33

        ;Text routine

textlo          = $34
texthi          = $35

        ;Raster interrupts

rastercount     = $36
screenmode      = $37
irqfirst        = $38
irqlast         = $39
irqcount        = $3a
newsprites      = $3b
savea           = $3c
savex           = $3d
savey           = $3e

        ;Scroll routine

scrollx         = $3f
scrolly         = $40
scrollsx        = $41
scrollsy        = $42
scrollcsx       = $43
scrollcsy       = $44
scrcounter      = $45
scradd          = $46
blockx          = $47
blocky          = $48
mapx            = $49
mapy            = $4a
mapindex        = $4b
scrposxl        = $4c
scrposxh        = $4d
scrposyl        = $4e
scrposyh        = $4f
screen          = $50
shiftpos        = $51

        ;Checking BG collisions

charmapx        = $52
charmapy        = $53
charblockx      = $54
charblocky      = $55

        ;Sprite Y coordinates for faster access

spry            = $56

        ;Soundeffect routine

sfxtmp          = $fb

        ;Non-zeropage memory locations

maptbllo        = $0400
maptblhi        = $0480
blktbllo        = $0500
blktblhi        = $0580
SPRCOLS         = $0600
LEVELWORK       = $0700
hiscores        = $0e60
hsname          = hiscores
hsdigit1        = hiscores+160
hsdigit2        = hiscores+170
hsdigit3        = hiscores+180
hsdigit4        = hiscores+190
cfg_usefastload = hiscores+200
cfg_showloadpic = hiscores+201
loader_setspriterange = $0f2a
loader_loadfile = $0f2d
loader_savehisc = $0f30
maincodestart   = $0f33
DOORDATA        = $7700
LEVELDATA       = $7900
MPLAYER         = $8000
mapsx           = $a800
mapsy           = $a801
MAP             = $a802
BLOCKCOLS       = $b680
BLOCKS          = $b700
CHARINFO        = $bf00
CHARS           = $c000
BOSS            = $c800
SPRITES         = $d000
COLORS          = $d800
SCREEN1         = $e000
SCREEN2         = $e400
ENEMIES         = $e800
CUTSCENE        = $9c00

        ;Doordata
NDOORS          = 128
doorx           = DOORDATA
doory           = DOORDATA+$80
doorl           = DOORDATA+$100
doord           = DOORDATA+$180

        ;Leveldata-workarea for currently loaded level
lvlshpx         = LEVELWORK
lvlshpy         = LEVELWORK+$40
lvlshpt         = LEVELWORK+$80
lvlshpp         = LEVELWORK+$c0

