;ͻ
;Enemy movement routines                                                      
;ͼ

;Ŀ
;PUNK                                                                         
;                                                                             
;Punk move routine.                                                           
;                                                                             
;Parameters: X:actor index                                                    
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

punk:           jsr random
                cmp #$fd
                bcc punk_noshoot
                lda #ITEM_PISTOL                ;Punk shoots with the pistol
                jsr enemyshoot
punk_noshoot:   lda shpxl,x
                sta alo
                lda shpxh,x
                sta ahi
                jsr getcharpos
                jsr movecharposup1
                lda shpd,x                      ;Which direction?
                beq punk_r
punk_l:         jsr movecharposleft1            ;Possible to go left?
                jsr getcharinfo
                and #CI_OBSTACLE
                bne reversedir
                ldy #-1
                jsr moveshpx
                jsr checkstairs
                bcc punk_anim
                jmp restoreandturn
punk_r:         jsr movecharposright1           ;Possible to go right?
                jsr getcharinfo
                and #CI_OBSTACLE
                bne reversedir
                ldy #1
                jsr moveshpx
                jsr checkstairs
                bcc punk_anim
                jmp restoreandturn
punk_anim:      inc shpfd,x
                lda shpfd,x
                cmp #$06
                bcc punk_anim1
                lda #$00
                sta shpfd,x
                lda shpf,x
                clc
                adc #$01
                and #$03
                sta shpf,x
punk_anim1:     rts

restoreandturn: lda alo
                sta shpxl,x
                lda ahi
                sta shpxh,x
reversedir:     lda shpd,x
                eor #$01
                sta shpd,x
                rts

;Ŀ
;MOTORIST                                                                     
;                                                                             
;Motorist move routine                                                        
;                                                                             
;Parameters: X:actor index                                                    
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

motorist:       lda shpxl,x
                sta alo
                lda shpxh,x
                sta ahi
                jsr getcharpos
                jsr movecharposup1
                lda shpd,x
                beq mot_r
mot_l:          jsr movecharposleft1
                jsr getcharinfo
                and #CI_OBSTACLE
                bne mot_turn
                lda shpsx,x
                eor #$ff
                clc
                adc #$01
                tay
                jsr moveshpx
                jsr checkstairs
                bcc mot_anim
                jmp mot_restoreandturn
mot_r:          jsr movecharposright1
                jsr getcharinfo
                and #CI_OBSTACLE
                bne mot_turn
                ldy shpsx,x
                jsr moveshpx
                jsr checkstairs
                bcc mot_anim
                jmp mot_restoreandturn
mot_anim:       dec shpfd,x             ;Acceleration
                bpl mot_anim1
                lda #$07
                sta shpfd,x
                lda shpsx,x
                cmp #$04
                bcs mot_anim1
                inc shpsx,x
mot_anim1:      rts
mot_turn:       lda #$00                ;Zero the speed on turning
                sta shpsx,x
                jmp reversedir
mot_restoreandturn:
                lda #$00
                sta shpsx,x
                jmp restoreandturn

;Ŀ
;JETPACK                                                                      
;                                                                             
;Jetpack-enemy's move routine                                                 
;                                                                             
;Parameters: X:actor index                                                    
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

jetpack:        lda shpf,x            ;Jetpack flame animation
                eor #$01
                sta shpf,x
                lda shpfd,x             ;Time to change speed?
                bne jp_ydone
                jsr random
                and #$03
                clc
                adc #$08
                sta shpfd,x
                jsr checksidex          ;(Home into player)
                bcs jp_left
                lda #$00
                sta shpd,x
                lda shpsx,x
                cmp #$03
                beq jp_xdone
                inc shpsx,x
                jmp jp_xdone
jp_left:        lda #$01
                sta shpd,x
                lda shpsx,x
                cmp #$fd
                beq jp_xdone
                dec shpsx,x
jp_xdone:       jsr isdead          ;If player is dead, use the last Y-coord
                bne jp_plrnotdead   ;(as the dead player goes way down and it
                jsr checksidey2     ;would look funny if the enemies followed
                jmp jp_plrdead      ;that)
jp_plrnotdead:  jsr checksidey
jp_plrdead:     bcs jp_up
                lda shpsy,x
                cmp #$02
                beq jp_ydone
                inc shpsy,x
                jmp jp_ydone
jp_up:          lda shpsy,x
                cmp #$fe
                beq jp_ydone
                dec shpsy,x
jp_ydone:       dec shpfd,x
                ldy shpsx,x
                jsr moveshpx
                ldy shpsy,x
                jsr moveshpy
                lda shpsy,x
                bne jp_noshoot
                jsr random
                cmp #$e0
                bcc jp_noshoot
                lda #ITEM_PLASMA
                jmp enemyshoot
jp_noshoot:     rts

;Ŀ
;TERRORIST                                                                    
;                                                                             
;Terrorist (the running guy) move routine                                     
;                                                                             
;Parameters: X:actor index                                                    
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

terrorist:      lda shpbits,x         ;Jumping?
                bne ter_fly
                jsr getcharpos
                jsr getcharinfo
                and #CI_WALK          ;Ground under feet?
                bne ter_nofall
                lda #$02
                sta shpsy,x
                inc shpbits,x
                jmp ter_fly
ter_nofall:     lda #$00
                inc shpfd,x
                ldy shpfd,x
                cpy #$04
                bcc ter_noframe
                sta shpfd,x
                inc shpf,x
                ldy shpf,x
                cpy #$03
                bcc ter_noframe
                sta shpf,x
                jsr random
                cmp #$80
                bcc ter_noframe
                lda #ITEM_PISTOL
                jsr enemyshoot
ter_noframe:    jsr ter_xmove
                jsr checkstairs
                bcc ter_nojump
                lda #$00
                sta shpfd,x
                lda #$fe
                sta shpsy,x
                inc shpbits,x
ter_nojump:     rts
ter_fly:        ldy shpsy,x
                jsr moveshpy
                lda #$03
                sta shpf,x
                inc shpfd,x
                lda shpfd,x           ;Y-acceleration
                cmp #$08
                bcc ter_fnot1
                lda #$00
                sta shpfd,x
                inc shpsy,x
                bmi ter_fnot1
                lda shpsy,x
                cmp #$02
                bcc ter_fnot1
                lda #$02
                sta shpsy,x
ter_fnot1:      jsr getcharpos        ;Check for bumping head into ceiling
                lda shpsy,x
                bpl ter_chkland
                dec charmapy
                jsr getcharinfo
                inc charmapy
                and #CI_OBSTACLE
                beq ter_nohead
                lda #$00
                sta shpfd,x
                sta shpsy,x
ter_nohead:     jsr ter_xmove
                rts
ter_chkland:    jsr getcharinfo
                and #CI_WALK
                bne ter_land
                jsr ter_xmove
                jsr getcharpos
                jsr getcharinfo
                and #CI_WALK
                bne ter_land
                rts
ter_land:       lda #$00
                sta shpbits,x
                sta shpf,x
                sta shpfd,x
                lda shpyl,x
                and #$f8
                sta shpyl,x
                lda #SFX_FOOTSTEP
                jsr playsfx
                rts
ter_xmove:      jsr movecharposup1
                lda shpd,x
                bne ter_left
                jsr movecharposright1
                jsr getcharinfo
                and #CI_OBSTACLE
                bne ter_reverse
                ldy #3
                jsr moveshpx
                rts
ter_left:       jsr movecharposleft1
                jsr getcharinfo
                and #CI_OBSTACLE
                bne ter_reverse
                ldy #-3
                jsr moveshpx
                rts
ter_reverse:    jmp reversedir

;Ŀ
;CYBERGOAT                                                                    
;                                                                             
;"Goat"-robot moveroutine                                                     
;                                                                             
;Parameters: X:actor index                                                    
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

cybergoat:      jsr random
                cmp #$ff
                bne cg_noturn
                jmp reversedir
cg_noturn:      cmp #$fc
                bcc cg_noshoot
                lda #ITEM_LASER                 ;Shoots with laser
                jsr enemyshoot
                bcc cg_noshoot
                lda #$01                        ;The laser is directed downwards
                sta shpsy,y                     ;so it can't be ducked that
cg_noshoot:     jmp punk_noshoot                ;easily

;Ŀ
;ROBOGOAT                                                                     
;                                                                             
;Robot goat on tracks, moveroutine.                                           
;                                                                             
;Parameters: X:actor index                                                    
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

robogoat:       jsr random
                cmp #$ff
                bne rg_noturn
                jsr rg_turnaround2
rg_noturn:      cmp #$f8
                bcc rg_noshoot
                lda #ITEM_LASER               ;Shoots also with laser
                jsr enemyshoot
rg_noshoot:     jsr getcharpos
                clc
                lda shpsx,x
                bpl rg_notleft1
                eor #$ff
                adc #$01
rg_notleft1:    adc shpfd,x                   ;Track animation according
                sta shpfd,x                   ;to speed
                cmp #$08
                bcc rg_noframe
                sbc #$08
                sta shpfd,x
                lda shpf,x
                eor #$01
                sta shpf,x
rg_noframe:     dec shpbits,x
                bpl rg_nospeed
                lda #$06
                sta shpbits,x
                lda shpd,x
                bne rg_subspeed
rg_addspeed:    lda shpsx,x
                cmp #$03
                beq rg_nospeed
                inc shpsx,x
                jmp rg_nospeed
rg_subspeed:    lda shpsx,x
                cmp #$fd
                beq rg_nospeed
                dec shpsx,x
rg_nospeed:     lda shpsx,x
                bmi rg_goleft
rg_goright:     jsr movecharposright1
rg_movement:    jsr getcharinfo
                and #CI_WALK
                beq rg_turnaround
                jsr movecharposup1
                jsr getcharinfo
                and #CI_OBSTACLE
                bne rg_turnaround
                ldy shpsx,x
                jmp moveshpx
rg_goleft:      jsr movecharposleft1
                jmp rg_movement
rg_turnaround:  lda #$00
                sta shpsx,x
                sta shpbits,x
rg_turnaround2: jmp reversedir

;Ŀ
;BAT                                                                          
;                                                                             
;Bat moveroutine.                                                             
;                                                                             
;Parameters: X:actor index                                                    
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

bat:            lda #$00
                inc shpfd,x
                ldy shpfd,x
                cpy #$04
                bne bat_not1
                sta shpfd,x
                lda shpf,x
                clc
                adc #$01
                and #$03
                sta shpf,x
bat_not1:       jsr getcharpos
                lda shpd,x
                bne bat_left
                jsr movecharposright1
                jsr getcharinfo
                and #CI_OBSTACLE
                bne bat_reverse
                ldy #3
                jsr moveshpx
                jmp bat_xdone
bat_left:       jsr movecharposleft1
                jsr getcharinfo
                and #CI_OBSTACLE
                bne bat_reverse
                ldy #-3
                jsr moveshpx
                jmp bat_xdone
bat_reverse:    jmp reversedir
bat_xdone:      dec shpbits,x
                bpl bat_noymod
                lda #$04
                sta shpbits,x
                lda shpsx,x
                bpl bat_ymodup
                inc shpsy,x
                lda shpsy,x
                cmp #$03
                bne bat_noymod
bat_yreverse:   lda shpsx,x
                eor #$80
                sta shpsx,x
                jmp bat_noymod
bat_ymodup:     dec shpsy,x
                lda shpsy,x
                cmp #$fd
                beq bat_yreverse
bat_noymod:     jsr getcharpos
                lda shpsy,x
                bne bat_ymove
                rts
bat_ymove:      bmi bat_up
                jsr movecharposdown1
bat_yback:      jsr getcharinfo
                and #CI_OBSTACLE
                bne bat_ybump
                ldy shpsy,x
                jmp moveshpy
bat_ybump:      lda shpsy,x
                and #$80
                sta shpsx,x
                lda #$00
                sta shpsy,x
                rts
bat_up:         jsr movecharposup1
                jmp bat_yback

;Ŀ
;SLIME                                                                        
;                                                                             
;Slime-blob moveroutine.                                                      
;                                                                             
;Parameters: X:actor index                                                    
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

slime:          lda shpf,x            ;Jumping?
                bne sl_jump
                lda shpfd,x           ;Time to prepare next jump?
                beq sl_newjump
                dec shpfd,x
                rts
sl_newjump:     inc shpf,x
                jsr random
                and #$03
                clc
                adc #$fa
                sta shpsy,x
                lda #0
                sta shpfd,x
sl_jump:        ldy shpsy,x
                jsr moveshpy
                inc shpfd,x
                lda shpfd,x           ;Y-acceleration
                cmp #$03
                bcc sl_fnot1
                lda #$00
                sta shpfd,x
                inc shpsy,x
                bmi sl_fnot1
                lda shpsy,x
                cmp #$05
                bcc sl_fnot1
                lda #$05
                sta shpsy,x
sl_fnot1:       jsr getcharpos        ;Check collision into ceiling
                lda shpsy,x
                bpl sl_chkland
                ldy #2
                jsr movecharposup
                jsr getcharinfo
                pha
                ldy #2
                jsr movecharposdown
                pla
                and #CI_OBSTACLE
                beq sl_nohead
                lda #$00
                sta shpfd,x
                sta shpsy,x
sl_nohead:      jsr sl_xmove
                rts
sl_chkland:     jsr getcharinfo
                and #CI_WALK
                bne sl_land
                jsr sl_xmove
                jsr getcharpos
                jsr getcharinfo
                and #CI_WALK
                bne sl_land
                rts
sl_land:        lda #$00
                sta shpf,x
                lda shpyl,x
                and #$f8
                sta shpyl,x
                jsr random
                and #$01
                sta shpd,x
                jsr random
                and #$1f
                adc #$10
                sta shpfd,x
                rts
sl_xmove:       jsr movecharposup1
                lda shpd,x
                bne sl_left
                jsr movecharposright1
                jsr getcharinfo
                and #CI_OBSTACLE
                bne sl_reverse
                ldy #3
                jsr moveshpx
                rts
sl_left:        jsr movecharposleft1
                jsr getcharinfo
                and #CI_OBSTACLE
                bne sl_reverse
                ldy #-3
                jsr moveshpx
                rts
sl_reverse:     jmp reversedir

;Ŀ
;PIG                                                                          
;                                                                             
;Mutant pig moveroutine                                                       
;                                                                             
;Parameters: X:actor index                                                    
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

pig:            lda shpf,x            ;Jumping?
                bne pig_jump
                lda shpfd,x           ;Time for next jump?
                beq pig_newjump
                dec shpfd,x
                rts
pig_newjump:    inc shpf,x
                jsr random
                and #$01
                clc
                adc #$fd
                sta shpsy,x
                lda #0
                sta shpfd,x
pig_jump:       ldy shpsy,x
                jsr moveshpy
                inc shpfd,x
                lda shpfd,x
                cmp #$06
                bcc pig_fnot1
                lda #$00
                sta shpfd,x
                inc shpsy,x
                bmi pig_fnot1
                lda shpsy,x
                cmp #$04
                bcc pig_fnot1
                lda #$04
                sta shpsy,x
pig_fnot1:      jsr getcharpos
                lda shpsy,x
                bpl pig_chkland
                ldy #3
                jsr movecharposup
                jsr getcharinfo
                pha
                ldy #3
                jsr movecharposdown
                pla
                and #CI_OBSTACLE
                beq pig_nohead
                lda #$00
                sta shpfd,x
                sta shpsy,x
pig_nohead:     jsr pig_xmove
                rts
pig_chkland:    jsr getcharinfo
                and #CI_WALK
                bne pig_land
                jsr pig_xmove
                jsr getcharpos
                jsr getcharinfo
                and #CI_WALK
                bne pig_land
                rts
pig_land:       lda #$00
                sta shpf,x
                lda shpyl,x
                and #$f8
                sta shpyl,x
                jsr random
                and #$07
                adc #$04
                sta shpfd,x
                rts
pig_xmove:      jsr movecharposup1
                lda shpd,x
                bne pig_left
                jsr movecharposright1
                jsr getcharinfo
                and #CI_OBSTACLE
                bne pig_reverse
                ldy #2
                jsr moveshpx
                rts
pig_left:       jsr movecharposleft1
                jsr getcharinfo
                and #CI_OBSTACLE
                bne pig_reverse
                ldy #-2
                jsr moveshpx
                rts
pig_reverse:    jmp reversedir

;Ŀ
;GUN                                                                          
;                                                                             
;Turret move(or actually shooting)routine.                                    
;                                                                             
;Parameters: X:actor index                                                    
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

gun:            jsr checksidey
                bcc gun_active
                rts
gun_active:     inc shpfd,x
                lda shpfd,x
                cmp #$14
                bcc gun_not1
                lda #$00
                sta shpfd,x
                lda shpf,x
                adc #$00                    ;Carry = 1
                and #$03
                sta shpf,x
gun_not1:       dec shpbits,x
                bpl gun_not2
                lda #$0a
                sta shpbits,x
                lda #ITEM_PLASMA
                jsr enemyshoot
                bcc gun_not2
                stx gun_xback+1
                lda shpf,x
                tax
                lda gunspd,x
                sta shpsx,y
                lda shpxl,y
                clc
                adc gunxlo,x
                sta shpxl,y
                lda shpxh,y
                adc gunxhi,x
                sta shpxh,y
                lda #$06
                sta shpsy,y
                lda #$00
                sta shpd,y
gun_xback:      ldx #$00
gun_not2:       rts

;Ŀ
;DROID                                                                        
;                                                                             
;Droid moveroutine.                                                           
;                                                                             
;Parameters: X:actor index                                                    
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

droid:          lda shpf,x            ;Rotating animation
                clc
                adc #$01
                and #$03
                sta shpf,x
                lda shpfd,x           ;Time to change speed?
                bne drd_ydone         ;(homes into the player)
                jsr random
                and #$03
                clc
                adc #$06
                sta shpfd,x
                jsr checksidex
                bcs drd_left
                lda #$00
                sta shpd,x
                lda shpsx,x
                cmp #$03
                beq drd_xdone
                inc shpsx,x
                jmp drd_xdone
drd_left:       lda #$01
                sta shpd,x
                lda shpsx,x
                cmp #$fd
                beq drd_xdone
                dec shpsx,x
drd_xdone:      lda shpyl             ;Adjust player Y-position
                sec                   ;for correct "homing in"
                sbc #20
                sta shpyl
                lda shpyh
                sbc #$00
                sta shpyh
                jsr checksidey
                php
                lda shpyl
                clc
                adc #20
                sta shpyl
                lda shpyh
                adc #$00
                sta shpyh
                plp
                bcs drd_up
                lda shpsy,x
                cmp #$01
                beq drd_ydone
                inc shpsy,x
                jmp drd_ydone
drd_up:         lda shpsy,x
                cmp #$ff
                beq drd_ydone
                dec shpsy,x
drd_ydone:      dec shpfd,x
                ldy shpsx,x
                jsr moveshpx
                ldy shpsy,x
                jsr moveshpy
                rts

;Ŀ
;CRAFT                                                                        
;                                                                             
;Flying craft moveroutine.                                                    
;                                                                             
;Parameters: X:actor index                                                    
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

craft:          inc shpfd,x
                lda shpfd,x
                cmp #$10
                bne cr_not1
                lda #$00
                sta shpfd,x
                lda shpf,x
                clc
                adc #$01
                and #$03
                sta shpf,x
cr_not1:        jsr getcharpos
                ldy shpf,x
                lda crtbl,y
                sta cr_move+1
                beq cr_movex
                bmi cr_up
                jsr movecharposdown1
                jsr getcharinfo
                pha
                jsr movecharposup1
                pla
                and #CI_OBSTACLE
                bne cr_movex
cr_move:        ldy #$00
                jsr moveshpy
                jmp cr_movex
cr_up:          jsr movecharposup1
                jsr getcharinfo
                pha
                jsr movecharposdown1
                pla
                and #CI_OBSTACLE
                beq cr_move
cr_movex:       lda shpd,x
                bne cr_left
                jsr movecharposright1
                jsr getcharinfo
                and #CI_OBSTACLE
                bne cr_reverse
                ldy #3
                jsr moveshpx
                jmp cr_movedone
cr_left:        jsr movecharposleft1
                jsr getcharinfo
                and #CI_OBSTACLE
                bne cr_reverse
                ldy #-3
                jsr moveshpx
                jmp cr_movedone
cr_reverse:     jsr reversedir
cr_movedone:    jsr random
                cmp #$fd
                bcc cr_noshoot
                lda #ITEM_LASER
                jmp enemyshoot
cr_noshoot:     rts

;Ŀ
;BOSS0                                                                        
;                                                                             
;Tank moveroutine.                                                            
;                                                                             
;Parameters: X:actor index                                                    
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

boss0:          jsr checkbossdeath
                jsr checkbossremove
                dec shpfd,x
                bmi b0_newspeed
                jmp b0_speeddone
b0_newspeed:    lda #SFX_TANK                   ;Emit sound :-)
                jsr playsfx
                lda shpd,x
                sta scrolltemp1
                lda #$01
                sta shpd,x
                jsr random
                cmp #$d0
                bcc b0_noshoot
                cmp #$f0
                bcs b0_shootgun
                lda #ITEM_PLASMA
                jsr enemyshoot
                jmp b0_noshoot
b0_shootgun:    lda #ITEM_PISTOL
                jsr enemyshoot
                bcc b0_noshoot
                lda shpyl,y
                sec
                sbc #$0b
                sta shpyl,y
                lda shpyh,y
                sbc #$00
                sta shpyh,y
                lda shpxl,y
                clc
                adc #$24
                sta shpxl,y
                lda shpxh,y
                adc #$00
                sta shpxh,y
                lda #$01
                sta shpsy,y
                jsr checksidey
                beq b0_noshoot
                bcc b0_noshoot
                lda #$ff
                sta shpsy,y
b0_noshoot:     lda scrolltemp1
                sta shpd,x
                lda #$06
                sta shpfd,x
                lda shpbits,x
                bmi b0_incspeed
                lda shpsx,x
                cmp #-2
                beq b0_inccount
                dec shpsx,x
                jmp b0_speeddone
b0_incspeed:    lda shpsx,x
                cmp #2
                beq b0_inccount
                inc shpsx,x
                jmp b0_speeddone
b0_inccount:    inc shpsy,x
                lda shpsy,x
                cmp #$0a
                bne b0_speeddone
                lda #$00
                sta shpsy,x
                lda shpbits,x
                eor #$80
                sta shpbits,x
b0_speeddone:   ldy shpsx,x
                jsr moveshpx
                lda shpd,x
                clc
                adc shpsx,x
                and #$07
                sta shpd,x
                lsr
                lsr
                sta shpf,x
                rts

;Ŀ
;BOSS1                                                                        
;                                                                             
;Tumor routine (spawning slimeblobs and animating)                            
;                                                                             
;Parameters: X:actor index                                                    
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

boss1:          jsr checkbossdeath
                jsr checkbossremove
                inc shpfd,x
                lda shpfd,x
                cmp #$05
                bcc boss1_not
                lda #$00
                sta shpfd,x
                lda shpf,x
                clc
                adc #$01
                and #$03
                sta shpf,x
boss1_not:      jsr random
                cmp #$f8
                bcc boss1_nospawn
                ldy #LASTNPC-3
boss1_search:   lda shpt,y
                beq boss1_found
                iny
                cpy #LASTNPC+1
                bcc boss1_search
boss1_nospawn:  rts
boss1_found:    lda #SHP_SLIME
                sta shpt,y
                jsr random
                and #$01
                sta shpd,y
                lda #$01
                sta shpf,y
                jsr random
                and #$03
                clc
                adc #$fa
                sta shpsy,y
                lda #$00
                sta shpfd,y
                sta shpimm,y
                lda #$ff
                sta shporg,y
                lda #$02
                sta shpp,y
                lda shpxl,x
                sta shpxl,y
                lda shpxh,x
                sta shpxh,y
                lda shpyl,x
                sta shpyl,y
                lda shpyh,x
                sta shpyh,y
                rts

;Ŀ
;BOSS2                                                                        
;                                                                             
;Giant mutantpig moveroutine.                                                 
;                                                                             
;Parameters: X:actor index                                                    
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

boss2:          jsr checkbossdeath
                jsr checkbossremove
                jsr checksidex
                lda #$00
                adc #$00
                sta shpd,x
                jsr random
                cmp #$f9
                bcc boss2_noshoot
                lda #ITEM_FLAME
                jsr enemyshoot
                bcc boss2_noshoot
                lda #$02
                sta shpsy,y
boss2_noshoot:  lda shpbits,x         ;Jump?
                bne boss2_jump
                dec shpfd,x
                bpl boss2_nonewjump
                lda #SFX_JUMP
                jsr playsfx
                inc shpbits,x
                lda #-4
                sta b2sy
                lda #$00
                sta shpfd,x
                jsr random
                and #$03
                sta b2jd
                cmp #$01
                beq boss2_jleft
                cmp #$03
                beq boss2_jright
boss2_nonewjump:rts
boss2_jleft:    lda shpsx,x
                bpl boss2_jok
                cmp #-32
                bcs boss2_jok
                lda #$03
                sta b2jd
boss2_jok:      rts
boss2_jright:   lda shpsx,x
                bmi boss2_jok
                cmp #32
                bcc boss2_jok
                lda #$01
                sta b2jd
                rts
boss2_jump:     inc shpfd,x
                lda shpfd,x
                cmp #$05
                bcc boss2_jnot
                lda #$00
                sta shpfd,x
                inc b2sy
boss2_jnot:     ldy b2sy
                jsr moveshpy
                jsr boss2_ground
                ldy b2jd
                lda shpsx,x
                clc
                adc b2spdtbl,y
                sta shpsx,x
                lda b2spdtbl,y
                asl
                tay
                jsr moveshpx
                jsr boss2_ground
                rts

boss2_ground:   lda b2sy
                bmi boss2_noground
                jsr getcharpos
                jsr getcharinfo
                and #CI_WALK
                beq boss2_noground
                lda shpyl,x
                and #$f8
                sta shpyl,x
                dec shpbits,x
                jsr random
                and #63
                sta shpfd,x
                pla
                pla
boss2_noground: rts

;Ŀ
;BOSS3                                                                        
;                                                                             
;Big jetpack-guy (final enemy) moveroutine                                    
;                                                                             
;Parameters: X:actor index                                                    
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

boss3:          jsr checkbossdeath
                jsr checkbossremove
                jmp jetpack

checkbossremove:lda shpxl,x
                sec
                sbc scrposxl
                sta alo
                lda shpxh,x
                sbc scrposxh
                sta ahi
                lda ahi
                bmi cbr_xneg
cbr_xpos:       cmp #>536
                beq cbr_xposlow
                bcc cbr_y
                bcs bremove
cbr_xposlow:    lda alo
                cmp #<536
                bcc cbr_y
                bcs bremove
cbr_xneg:       cmp #>-168
                beq cbr_xneglow
                bcc bremove
                bcs cbr_y
cbr_xneglow:    lda alo
                cmp #<-168
                bcc bremove
cbr_y:          lda shpyl,x
                sec
                sbc scrposyl
                sta alo
                lda shpyh,x
                sbc scrposyh
                sta ahi
                lda ahi
                bmi cbr_yneg
cbr_ypos:       cmp #>314
                beq cbr_yposlow
                bcc cbr_done
                bcs bremove
cbr_yposlow:    lda alo
                cmp #<314
                bcc cbr_done
                bcs bremove
cbr_yneg:       cmp #>-78
                beq cbr_yneglow
                bcc bremove
                bcs cbr_done
cbr_yneglow:    lda alo
                cmp #<-78
                bcc bremove
cbr_done:       rts

bremove:        jsr removeshape
                lda #$00
                sta bossfight
                stx alo
                jsr leveltune
                ldx alo
                pla
                pla
                rts

checkbossdeath: lda shpp,x              ;When the jetpack-robot explodes, the
                beq cbd_yes             ;scientist (Dr.Ultrashred) comes out
                rts
cbd_yes:        lda bossdeath
                bne cbd_doexpl
                lda shpt,x
                cmp #SHP_BOSS3
                bne cbd_noscientist
                lda #SHP_SCIENTIST
                sta shpt+LASTNPC
                lda shpxl,x
                sta shpxl+LASTNPC
                lda shpxh,x
                sta shpxh+LASTNPC
                lda shpyl,x
                sta shpyl+LASTNPC
                lda shpyh,x
                sta shpyh+LASTNPC
                lda #-4
                sta shpsy+LASTNPC
                lda #0
                sta shpf+LASTNPC
                sta shpfd+LASTNPC
                lda #$ff
                sta shporg+LASTNPC
cbd_noscientist:lda #250              ;5 seconds of explosions
                sta bossdeath
                lda #$00
                sta bossexpldelay
                sta bossexplturn
                ldy #NBOSSEXP-1       ;Initialize boss-explosions
cbd_initloop:   lda #$ff
                sta bossexpf,y
                dey
                bpl cbd_initloop
cbd_doexpl:     stx scrolltemp1
                ldx #NBOSSEXP-1
cbd_explloop:   lda bossexpf,x
                bmi cbd_explskip
                inc bossexpfd,x
                lda bossexpfd,x
                cmp #$03
                bcc cbd_explskip
                lda #$00
                sta bossexpfd,x
                inc bossexpf,x
                lda bossexpf,x
                cmp #101
                bcc cbd_explskip
                lda #$ff
                sta bossexpf,x
cbd_explskip:   dex
                bpl cbd_explloop
                dec bossexpldelay
                bmi cbd_new
                jmp cbd_nonew
cbd_new:        ldy #$04
                lda bossdeath
                cmp #150
                bcs cbd_notslower
                iny
                cmp #75
                bcs cbd_notslower
                iny
cbd_notslower:  sty bossexpldelay
                lda #SFX_EXPLOSION
                jsr playsfx
                ldy bossexplturn
                tya
                iny
                cpy #NBOSSEXP
                bcc cbd_notover
                ldy #$00
cbd_notover:    sty bossexplturn
                tay
                ldx scrolltemp1
                lda shpt,x
                sec
                sbc #SHP_BOSS0
                tax
                lda bossxmod,x
                sta bossexpxl,y
                lda bossymod,x
                sta bossexpyl,y
                jsr random
                and bossxand,x
                clc
                adc bossexpxl,y
                sta bossexpxl,y
                jsr random
                and bossyand,x
                clc
                adc bossexpyl,y
                sta bossexpyl,y
                lda #96
                sta bossexpf,y
                lda #$00
                sta bossexpfd,y
cbd_nonew:      lda #$00
                sta alo
                lda #$01
                sta ahi
                jsr addscore
                dec bossdeath
                bne cbd_xback
                ldx scrolltemp1
                lda shpt,x
                sta deadbosstype
                lda #$00
                sta bossfight
                sta shpt,x
                lda deadbosstype
                cmp #SHP_BOSS3
                beq cbd_xback
                jsr leveltune
cbd_xback:      ldx scrolltemp1
                pla
                pla
                rts

NBOSSEXP        = 5

checksidex:     lda shpxh,x           ;On player's left or right side?
                cmp shpxh
                bcc chks_donex
                bne chks_donex
                lda shpxl,x
                cmp shpxl
chks_donex:     rts

checksidey:     lda shpyh,x           ;Above or below player?
                cmp shpyh
                bcc chks_doney
                bne chks_doney
                lda shpyl,x
                cmp shpyl
chks_doney:     rts

checksidey2:    lda shpyh,x
                cmp lastyh
                bcc chks_doney2
                bne chks_doney2
                lda shpyl,x
                cmp lastyl
chks_doney2:    rts

scienta:        lda shpf,x
                bne sci_liedown
                lda shpsy,x
                bmi sci_nogndchk
                jsr getcharpos
                jsr getcharinfo
                and #CI_WALK
                beq sci_nogndchk
                inc shpf,x
                lda shpyl,x
                and #$f8
                sta shpyl,x
sci_liedown:    rts
sci_nogndchk:   inc shpfd,x
                lda shpfd,x
                and #$03
                bne sci_nospdchng
                inc shpsy,x
                lda shpsy,x
                bmi sci_nospdchng
                cmp #$04
                bcc sci_nospdchng
                lda #$04
                sta shpsy,x
sci_nospdchng:  ldy shpsy,x
                jsr moveshpy
                ldy #$01
                jsr moveshpx
                rts
