;ͻ
;METAL WARRIOR loader                                                         
;ͼ

fastloadstatus = $0800
fileopen       = $0803

;Ŀ
;LOADLEVEL                                                                    
;                                                                             
;Loads the charset,blocks,map and sprites that belong to the level.           
;                                                                             
;Parameters: A: Level number                                                  
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

loadlevel:      sta level
ll_nostuff:     cmp loadedlevel
                beq ll_done
                sta loadedlevel
                clc
                adc #"0"
                tay
                ldx #"L"
                jsr load
                jsr getbosscols
ll_done:        ldx loadedlevel
                lda lvlcoltbl1,x
                sta setmc1
                lda lvlcoltbl2,x
                sta setmc2
                lda lvlbgtbl,x
                sta setbg
                rts

;Ŀ
;LOAD                                                                         
;                                                                             
;Loads a file.                                                                
;                                                                             
;Parameters: X,Y: first 2 letters of filename                                 
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

load:           stx load_again+1          ;Store name
                sty load_again2+1
                jsr load_prepare
load_again:     ldx #$00
load_again2:    ldy #$00
                jsr loader_loadfile
                bcc load_ok
                ldx #250
                lda #MSG_ERROR
                jsr newmsg
                jsr com_fireorspace
                jmp load_again
load_ok:        jsr initmap
                jmp initblocks

load_prepare:   lda #$00                ;Blank screen
                sta screenmode
load_initwait:  lda playmusic+1         ;Fade music if necessary
                bmi load_skipwait
                lda #$01
                sta pm_fade+1
                lda fastloadstatus      ;Don't need to wait if fastloading
                bne load_skipwait
                ldx #$40                ;Wait 64 frames
                jsr waitraster2
                lda #$ff                ;Stop musicroutine
                sta playmusic+1
load_skipwait:  lda $d011               ;Ensure we're at the bottom border
                bpl load_skipwait
                and #$7f
                ora #$50                ;In case we do not fastload, physically
                sta $d011               ;blank the screen
                rts

;Ŀ
;SAVEHISCORE                                                                  
;                                                                             
;Saves hiscores.                                                              
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

savehiscore:    jsr load_prepare
                sei
                lda #$03
                sta $d011
                jmp loader_savehisc


