;ͻ
;METAL WARRIOR                                                                
;                                                                             
;Version 1.1 (bitmap changes) done 8/1999.                                    
;Version 1.2 (more bitmap changes + hiscoresaver) done 11/1999.               
;Version 1.2p (pucrunch & fastloader) done 10/2000.                           
;Version 1.3 (Covert BitOps version) done 3/2002.                             
;Version 1.4 (alldrive fastloader) done 1/2004.                               
;Version 1.5 (raster + spritemultiplex improvement) done 6/2007.              
;Version 1.6 (2-bit fastloader) done 2/2012.                                  
;ͼ

                include define.s

                processor 6502
                org maincodestart


;Ŀ
;Main program entrypoint. Initializing different subsystems.                  
;

                ldx #$ff
                txs
                cld
                ldx #"P"
                ldy #"2"
                jsr loader_loadfile     ;Load bank 0 data
                ldx #210-4              ;Do not use fastload transfer
                ldy #210+21+2           ;during the inventory sprites
                jsr loader_setspriterange
                jsr initraster          ;Init raster IRQs + turn kernal off
                jsr initscroll          ;Initialize scrolling variables
                jsr initblocks          ;Calculate startaddresses for blocks
                jsr getsprcols          ;Get correct colors for sprites
                jsr drawpanel           ;Draw the scorepanel
                lda #LVL_TITLE          ;Load the "level" containing title
                jsr loadlevel           ;screen graphics
                lda #SCRM_TITLE
                sta screenmode

;Ŀ
;TITLE                                                                        
;                                                                             
;Title screen                                                                 
;

title:          lda #$00                ;Setup titlescreen mode (credits,
title2:         sta titlemode           ;hiscore, etc)
                lda #$00
                sta titletimelo         ;And timecounter (for changing modes)
                sta titletimehi
                sta cheatletter
                lda #MUS_TITLE          ;Play title screen music
                jsr playtune
titleloop:      jsr clearscreen
                ldx titlemode           ;Selfmodifying jump according to
                lda ttbllo,x            ;titlescreen mode
                sta titlejsr+1
                lda ttblhi,x
                sta titlejsr+2
                jsr drawlogo            ;Draw always MW logo first
titlejsr:       jsr $0000
waitfire:       jsr waitraster
                jsr random              ;Call random routine while waiting to
                jsr titlecolors         ;get different "random seed"
                jsr getcontrols         ;Get joystick & keypress
                ldx cheatletter
                lda keyval              ;Check for toggling fastloader
                cmp #$ff                ;Check for entering cheatstring "BOFH"
                beq tcheat2             ;on keyboard
                cmp cheatstring,x
                bne tcheat1
                inx
                cpx #$04
                bcc tcheat2
                lda #$02                ;If cheat activated, flash screen and
                sta $d020               ;modify lives decreasing code
                jsr waitraster
                jsr waitraster
                jsr waitraster
                lda #$ad
                sta chd_livesdec
tcheat1:        lda #$00
                sta $d020
                tax
tcheat2:        stx cheatletter
                jsr getfireclick
                bcs initgame
                inc titletimelo
                bne waitfire
                inc titletimehi
                lda titletimehi         ;Check if enough time has elapsed for
                cmp #$02                ;a mode change
                bne waitfire
                lda #$00
                sta titletimehi
                ldx titlemode
                inx
                txa
                and #$03
                sta titlemode
                jmp titleloop

;Ŀ
;INITGAME                                                                     
;                                                                             
;Initializing game status                                                     
;

initgame:       jsr initmsg             ;Initialize - message system
                jsr inititems           ;           - player inventory
                jsr initcomm            ;           - communication
                jsr initplayer          ;           - player status
                jsr updatescore
                lda #$00                ;Reset pausemode
                sta pausemode
                jsr cutscene            ;Show intro cutscene
                lda #LVL_INSIDE         ;Game starts from the "INSIDE" level
                jsr loadlevel
                ldx #"L"                ;Load enemy/item initial status
                ldy #"D"                ;(a file called "LD" - LevelData)
                jsr load
                jsr getleveldata
                jsr leveltune
                lda #MSG_THOUGHT1       ;Show intro message
                ldx #200
                jsr newmsg
                jsr clearshapes
                jsr initnextlife

;Ŀ
;EPISODE1,2,3,4                                                               
;                                                                             
;Initializing code for different game episodes                                
;(strictly hardcoded, no "script" system for instance)                        
;

episode1:       lda #$01
                sta episode
                sta actorkeytbl+A_FAUSTUS*$10+K_SADOK   ;Init communication
                sta actorkeytbl+A_GOAT*$10+K_SADOK      ;keywords for episode1
                sta actorkeytbl+A_PHANTASM*$10+K_SADOK
                sta actorkeytbl+A_DETECTIVE*$10+K_SADOK
                lda #LVL_INSIDE
                ldx #7
                ldy #4
                jsr warpmap
                jmp mainloop
endepisode1:    jsr com_addscore2
                jsr com_fireorspace
                pla
                pla
                pla
                pla
                lda #$00
                sta actorkeytbl+A_FAUSTUS*$10+K_JOIN    ;Episode 1 ends. Update
                sta actorkeytbl+A_GOAT*$10+K_JOIN       ;communication keywords
                sta actorkeytbl+A_PHANTASM*$10+K_SADOK
                sta actorkeytbl+A_PHANTASM*$10+K_JOIN
                lda #$01
                jsr cutscene
episode2:       lda #$02
                sta episode
                jsr inl_maxpower
                lda #SHP_JETPACK                ;Initialize the "assasination
                sta LEVELDATA+$3e+$80           ;attempt" at beginning of
                sta LEVELDATA+$3f+$80           ;Episode 2
                lda #$08
                sta LEVELDATA+$3e+$c0
                sta LEVELDATA+$3f+$c0
                lda #$01
                sta murder
                sta actorkeytbl+A_FAUSTUS*$10+K_MURDER
                sta actorkeytbl+A_GOAT*$10+K_MURDER
                sta actorkeytbl+A_PHANTASM*$10+K_MURDER
                sta actorkeytbl+A_DETECTIVE*$10+K_MURDER
                sta actorkeytbl+A_HITMAN*$10+K_HITMEN ;To not get stuck in case
                jsr getleveldata                ;some investigations were missing
                lda #LVL_CITY
                ldx #58
                ldy #14
                jsr warpmap
                jmp mainloop
endepisode2:    lda #$00
                sta deadbosstype
                lda #$02
                jsr cutscene
episode3:       lda #$03
                sta episode
                jsr inl_maxpower
                lda #25                         ;SADOK appears inside the cave
                sta LEVELDATA+$300+$3f+$00      ;level in episode 3
                lda #49
                sta LEVELDATA+$300+$3f+$40
                lda #SHP_SADOK
                sta LEVELDATA+$300+$3f+$80
                lda #$01
                sta LEVELDATA+$300+$3f+$c0
                lda #35                         ;Move other characters around
                sta LEVELDATA+$100+$02+$00
                lda #14
                sta LEVELDATA+$100+$02+$40
                lda #30
                sta LEVELDATA+$100+$03+$00
                lda #13
                sta LEVELDATA+$100+$03+$40
                sta LEVELDATA+$100+$01+$40
                lda #34
                sta LEVELDATA+$100+$01+$00
                jsr getleveldata
                ldx #$00                        ;Update keywords again
                stx actorkeytbl+A_FAUSTUS*$10+K_MURDER
                stx actorkeytbl+A_FAUSTUS*$10+K_HITMEN
                stx actorkeytbl+A_FAUSTUS*$10+K_SADOK
                stx actorkeytbl+A_GOAT*$10+K_MURDER
                stx actorkeytbl+A_GOAT*$10+K_HITMEN
                stx actorkeytbl+A_GOAT*$10+K_SADOK
                stx actorkeytbl+A_PHANTASM*$10+K_MURDER
                stx actorkeytbl+A_PHANTASM*$10+K_HITMEN
                stx actorkeytbl+A_DETECTIVE*$10+K_SADOK
                stx actorkeytbl+A_DETECTIVE*$10+K_MURDER
                inx                             ;Listn avainsanoja
                stx actorkeytbl+A_FAUSTUS*$10+K_CAVES
                stx actorkeytbl+A_FAUSTUS*$10+K_PLOT
                stx actorkeytbl+A_GOAT*$10+K_CAVES
                stx actorkeytbl+A_GOAT*$10+K_PLOT
                stx actorkeytbl+A_PHANTASM*$10+K_CAVES
                stx actorkeytbl+A_PHANTASM*$10+K_PLOT
                stx actorkeytbl+A_DETECTIVE*$10+K_PLOT
                lda #LVL_INSIDE                 ;Episode 3 starts from the
                ldx #32                         ;rehearsal place
                ldy #14
                jsr warpmap
                jmp mainloop
endepisode3:    lda #$03
                jsr cutscene
episode4:       lda #$04
                sta episode
                jsr inl_maxpower
                lda #$00
                sta deadbosstype
                sta LEVELDATA+$300+$3f+$80      ;Remove actors (SADOK & PHANTASM)
                sta LEVELDATA+$100+$03+$80
                tay
epi4_disk:      lda plrinvt,y                   ;Put evidence disk to inventory.
                bmi epi4_empty                  ;If no room, overwrite 7th
                iny                             ;inventory slot
                cpy #$08
                bcc epi4_disk
                ldy #$07
epi4_empty:     lda #ITEM_EVIDENCE
                sta plrinvt,y
                lda #$01
                sta plrinvp,y
                jsr updatepower
                lda #47                         ;Move FAUSTUS & GOAT
                sta LEVELDATA+$100+$01+$00
                lda #49
                sta LEVELDATA+$100+$02+$00
                lda #6
                sta LEVELDATA+$100+$02+$40
                sta LEVELDATA+$100+$01+$40
                jsr getleveldata
                ldx #$00                        ;Update keywords
                stx actorkeytbl+A_FAUSTUS*$10+K_CAVES
                stx actorkeytbl+A_FAUSTUS*$10+K_PLOT
                stx actorkeytbl+A_GOAT*$10+K_CAVES
                stx actorkeytbl+A_GOAT*$10+K_PLOT
                stx actorkeytbl+A_DETECTIVE*$10+K_PLOT
                inx
                stx actorkeytbl+A_FAUSTUS*$10+K_WHAT
                stx actorkeytbl+A_FAUSTUS*$10+K_EVD
                stx actorkeytbl+A_GOAT*$10+K_WHAT
                stx actorkeytbl+A_GOAT*$10+K_EVD
                stx actorkeytbl+A_DETECTIVE*$10+K_EVD
                lda #LVL_CITY                   ;Episode 4 starts at the city
                ldx #9                          ;gate
                ldy #14
                jsr warpmap
                jmp mainloop

;Ŀ
;MAINLOOP                                                                     
;                                                                             
;Peli-silmukka!                                                               
;

mainloop:       jsr getcontrols         ;Take player controls
                jsr checkpause
                lda pausemode           ;If game paused, skip game advancing
                bne ml_skipmove         ;code
                jsr checkdeath          ;Player died?
                jsr checkwarp           ;Entered a door?
                jsr checkcomm           ;Communication?
                jsr addshapes           ;Add actors to screen if needed
                jsr moveshapes          ;Move actors (including player)
                jsr selectitem          ;Selecting inventory item
                jsr shoot               ;Handle player attacks
                jsr plrbulletcoll       ;Check collision of player bullets
                jsr enmbulletcoll       ;Check collision of enemy bullets
                jsr enemycoll           ;Check collision of enemies to player
                jsr checkscroll         ;Check need for scrolling
                jsr doscroll            ;Do scrolling logic
                jsr updateshapes        ;Transform actors into sprites
                jsr updatesprites       ;Sort sprites
                jsr waitraster          ;Wait for rasterbeam to be at scorepanel
                inc newsprites          ;New sprites will be on
                jsr bganim              ;Background animation (waterfalls etc.)
                jsr shiftscreen         ;Do hard work of scrolling (screen shift)
ml_skipmove:    jsr updatescore         ;Update score
                jsr selectsfx           ;Select music/sound effects
                lda deadbosstype        ;Special code executed when certain
                cmp #$ff                ;"boss enemies" die (end of episodes)
                beq ml_sadok
                cmp #SHP_BOSS0
                beq ml_tank
                cmp #SHP_BOSS3
                beq victory
                jmp mainloop
ml_tank:        jmp endepisode2
ml_sadok:       jmp endepisode3

        ;Victory code

victory:        lda #$01                ;Set music to fade
                sta pm_fade+1
                ldx #$40                ;Wait 64 frames
                jsr waitraster2
                lda #MUS_BONUS          ;Play the bonus-counting music
                jsr playtune
                lda #MSG_BONUS1         ;and show appropriate messages
                ldx #100
                jsr newmsg
                lda #200
                sta scrolltemp1
ml_count1:      jsr waitraster          ;First loop: victory bonus
                lda #$01
                sta ahi
                lda #$00
                sta alo
                jsr addscore_nl
                jsr updatescore
                dec scrolltemp1
                bne ml_count1
                ldx #25
                jsr waitraster2
                lda #MSG_BONUS2
                ldx #100
                jsr newmsg
ml_count2:      lda lives               ;Second loop: lives bonus
                beq ml_count2d
                dec lives
                lda #$50
                sta ahi
                lda #$00
                sta alo
                jsr addscore_nl
                jsr updatescore
                ldx #25
                jsr waitraster2
                jmp ml_count2
ml_count2d:     lda #MSG_BONUS3
                ldx #100
                jsr newmsg
ml_count3:      lda shpp                ;Third loop: energy bonus
                beq ml_count3d
                dec shpp
                lda #$02
                sta ahi
                lda #$00
                sta alo
                jsr addscore_nl
                jsr updatescore
                ldx #2
                jsr waitraster2
                jmp ml_count3
ml_count3d:     ldx #25
                jsr waitraster2
                lda #MSG_BONUS4
                ldx #100
                jsr newmsg
                lda #$00
                sta scrolltemp4
ml_count4:      ldy scrolltemp4         ;Fourth loop: go thru all weapons
                cpy #$08
                beq ml_count4d
                lda plrinvt,y
                cmp #ITEM_RIFLE
                bcc ml_skipc4
                cmp #ITEM_HEALTH
                bcs ml_skipc4
ml_count5:      jsr decammo2            ;Fifth loop (inner loop of 4th loop):
                lda #$00                ;count ammo bonus
                sta ahi
                lda #$50
                sta alo
                jsr addscore_nl
                jsr updatescore
                jsr waitraster
                ldy scrolltemp4
                lda plrinvp,y
                bne ml_count5
                ldx #25
                jsr waitraster2
ml_skipc4:      inc scrolltemp4
                jmp ml_count4
ml_count4d:     lda #$05                ;Play ending cutscene
                jsr cutscene
                jmp gameover

        ;Pause & quitting check routine

checkpause:     lda keyval
                cmp #KEY_Q
                bne cp_noabort
                lda pausemode
                beq cp_noabort
                pla
                pla
gameover:       jsr updatescore         ;Game over routine:
                lda #LVL_TITLE
                sta bossdeath
                jsr loadlevel           ;Load title graphics again
                jsr initscroll          ;Init scrolling for correct placement
                jsr clearscreen         ;of sprites
                jsr clearsprites
                lda #SCRM_TITLE
                sta screenmode
                jsr hiscore             ;Check for hiscores, then go back to
                jmp title2              ;title screen
cp_noabort:     cmp #KEY_RUNSTOP
                bne cp_nopause
                lda pausemode
                eor #$01
                sta pausemode
                ldx #50
                clc
                adc #MSG_PAUSE1
                jsr newmsg
cp_nopause:     rts

                include player.s
                include enemies.s
                include items.s
                include shapes.s
                include scroll.s
                include load.s
                include raster.s
                include title.s
                include comm.s
                include sfx.s
                include data.s

                org DOORDATA    ;Just a test to see if code grows too large
                dc.b 0

                include music.s

