;ͻ
;Title screen, hiscoreroutines, message routine, cutsceneroutine              
;ͼ

;Ŀ
;CLEARSCREEN                                                                  
;                                                                             
;Clears the visible gamescreen.                                               
;                                                                             
;Parameters: A:color (only when calling clearscreen2)                         
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

clearscreen:    lda #$00
clearscreen2:   sta cscr_color+1
                ldx screen
                lda #$00
                sta scrolltemp1
                sta scrolltemp3
                lda scradrtblhi,x
                sta scrolltemp2
                lda #>COLORS
                sta scrolltemp4
                ldx #ROWS
cscr_loop1:     lda #$20
                ldy #39
cscr_loop2:     lda #$20
                sta (scrolltemp1),y
cscr_color:     lda #$00
                sta (scrolltemp3),y
                dey
                bpl cscr_loop2
                lda scrolltemp1
                clc
                adc #40
                bcc cscr_notover1
                inc scrolltemp2
                inc scrolltemp4
cscr_notover1:  sta scrolltemp1
                sta scrolltemp3
                dex
                bne cscr_loop1
                stx tcoldelay
                stx tcolcnt
                rts

;Ŀ
;DRAWLOGO                                                                     
;                                                                             
;Draws the MW-logo.                                                           
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X                                                                
;

drawlogo:       ldx screen
                lda #$00
                sta drl_store+1
                lda scradrtblhi,x
                sta drl_store+2
                ldx #119
drl_loop:       txa
                clc
                adc #$40
drl_store:      sta SCREEN1,x
                lda #$0d
                sta $d800,x
                dex
                bpl drl_loop
                rts

;Ŀ
;DRAWPANEL                                                                    
;                                                                             
;Draws the scorepanel to the bottom of the screen.                            
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X                                                                
;

drawpanel:      ldx #5*40
drpnloop:       lda panelcolors-1,x
                sta COLORS+19*40-1,x
                dex
                bne drpnloop
                ldx #39
                lda #$01
drpnloop2:      sta COLORS+18*40,x
                dex
                bpl drpnloop2
                rts

;Ŀ
;PRINTTITLE, PRINTHISCORE, PRINTINSTR, PRINTSTORY                             
;                                                                             
;Draws the different title screen modes.                                      
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

printtitle:     lda #<ttext1
                sta textlo
                lda #>ttext1
                sta texthi
                ldy #5
                jsr printtextc
                ldy #8
                jsr printtextc
                ldy #10
                jsr printtextc
                ldy #12
                jsr printtextc
                ldy #15
                jsr printtextc
                rts

printhiscore:   lda #<ttext5
                sta textlo
                lda #>ttext5
                sta texthi
                ldy #5
                jsr printtextc
                lda scrolltemp1
                clc
                adc #56
                sta scrolltemp1
                bcc phs_notover1
                inc scrolltemp2
phs_notover1:   ldx #$00
phs_loop:       jsr phs_print
                lda scrolltemp1
                clc
                adc #40
                sta scrolltemp1
                bcc phs_notover2
                inc scrolltemp2
phs_notover2:   inx
                cpx #$0a
                bne phs_loop
                rts

phs_print:      lda hsnumber1,x
                ldy #$00
                sta (scrolltemp1),y
                iny
                lda hsnumber2,x
                sta (scrolltemp1),y
phs_name:       ldy #3
                txa
                pha
                asl
                asl
                asl
                asl
                tax
phs_nameloop:   lda hsname,x
                cmp #$40
                bcc phs_not40
                sbc #$40
phs_not40:      sta (scrolltemp1),y
                inx
                iny
                txa
                and #$0f
                bne phs_nameloop
                iny
                pla
                tax
                lda hsdigit4,x
                jsr phs_digit
                lda hsdigit3,x
                jsr phs_digit
                lda hsdigit2,x
                jsr phs_digit
                lda hsdigit1,x
                jsr phs_digit
                rts

phs_digit:      pha
                lsr
                lsr
                lsr
                lsr
                clc
                adc #48
                sta (scrolltemp1),y
                iny
                pla
                and #$0f
                adc #48
                sta (scrolltemp1),y
                iny
                rts

printstory:     lda #<ttext6
                sta textlo
                lda #>ttext6
                sta texthi
                ldy #5
                jsr printtextc
                ldy #8
prs_loop:       sty alo
                jsr printtextc
                ldy alo
                iny
                cpy #15
                bne prs_loop
                rts

printinstr:     lda #<ttext7
                sta textlo
                lda #>ttext7
                sta texthi
                ldy #5
                jsr printtextc
                ldy #7
pri_loop:       sty alo
                jsr printtextc
                ldy alo
                iny
                cpy #17
                bne pri_loop
                rts


;Ŀ
;HISCORE                                                                      
;                                                                             
;Called when game ends, checks for hiscore entry                              
;                                                                             
;Parameters: -                                                                
;Returns: A:0=no hiscore 1=hiscore, name entered                              
;Modifies: A,X,Y                                                              
;

hiscore:
checkhiscore:   ldx #$00                         ;Start from the top
chsc_loop:      lda score+3
                cmp hsdigit4,x
                beq chsc_check2
                bcs chsc_found
                bcc chsc_next
chsc_check2:    lda score+2
                cmp hsdigit3,x
                beq chsc_check3
                bcs chsc_found
                bcc chsc_next
chsc_check3:    lda score+1
                cmp hsdigit2,x
                beq chsc_check4
                bcs chsc_found
                bcc chsc_next
chsc_check4:    lda score
                cmp hsdigit1,x
                beq chsc_next
                bcs chsc_found
chsc_next:      inx
                cpx #$0a
                bne chsc_loop
                lda #$00
                rts
chsc_found:     stx alo
                txa
                asl
                asl
                asl
                asl
                sta ahi
                cpx #$09
                beq hsc_skipshift
                ldx #$08
hsc_shiftscore: lda hsdigit1,x                  ;Move the scores downwards
                sta hsdigit1+1,x
                lda hsdigit2,x
                sta hsdigit2+1,x
                lda hsdigit3,x
                sta hsdigit3+1,x
                lda hsdigit4,x
                sta hsdigit4+1,x
                cpx alo
                beq hsc_ssdone
                dex
                jmp hsc_shiftscore
hsc_ssdone:     ldx #8*16+15
hsc_shiftname:  lda hsname,x            ;Move the names downwards
                sta hsname+16,x
                cpx ahi
                beq hsc_skipshift
                dex
                jmp hsc_shiftname
hsc_skipshift:  ldx alo
                lda score               ;Save player scores
                sta hsdigit1,x
                lda score+1
                sta hsdigit2,x
                lda score+2
                sta hsdigit3,x
                lda score+3
                sta hsdigit4,x
                ldy #$0f
                ldx ahi
                lda #"."
hsc_clearname:  sta hsname,x
                inx
                dey
                bpl hsc_clearname
                lda #MUS_HISCORE        ;Set hiscoremusic to play
                jsr playtune
                jsr drawlogo
                lda #<htext1
                sta textlo
                lda #>htext1
                sta texthi
                ldx #39
hsc_colors:     sta $d800+10*40,x
                dex
                bpl hsc_colors
                ldy #8
                jsr printtextc
                ldy #9
                jsr printtextc
                lda scrolltemp1
                clc
                adc #50
                sta scrolltemp1
                bcc hsc_notover1
                inc scrolltemp2
hsc_notover1:   lda #$00                        ;"cursor" position
                sta scrolltemp3
hsc_typeloop:   ldx alo
                jsr phs_print
hsc_waitkey:    jsr waitraster
                jsr hiscorecolors
                jsr getcontrols
                lda keyval
                cmp #$ff
                beq hsc_waitkey
                tax
                lda asciitable,x
                bmi hsc_del
                cmp #13
                beq hsc_ready
                tay
                lda scrolltemp3
                cmp #$10
                bcs hsc_typeloop
                clc
                adc ahi
                tax
                tya
                sta hsname,x
                inc scrolltemp3
                jmp hsc_typeloop
hsc_del:        dec scrolltemp3
                bpl hsc_notover
                lda #$00
                sta scrolltemp3
hsc_notover:    lda scrolltemp3
                clc
                adc ahi
                tax
                lda #"."
                sta hsname,x
                jmp hsc_typeloop
hsc_ready:      jsr savehiscore
                lda #SCRM_TITLE
                sta screenmode
                lda #$01
                rts

;Ŀ
;PRINTTEXTC                                                                   
;                                                                             
;Centered text printing                                                       
;                                                                             
;Parameters: Y:row,textlo,texthi                                              
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

printtextc:     tya
                pha
                ldy #0
ptc_getlen:     lda (textlo),y
                beq ptc_ready
                iny
                bne ptc_getlen
ptc_ready:      tya
                lsr
                sta scrolltemp1
                lda #20
                sec
                sbc scrolltemp1
                tax
                pla
                tay

;Ŀ
;PRINTTEXT                                                                    
;                                                                             
;Prints a null-terminated string                                              
;                                                                             
;Parameters: X:column,Y:row,textlo,texthi                                     
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

printtext:      jsr printtext_getpos
pt_mulready:    ldy #0
pt_printloop:   lda (textlo),y
                beq pt_printend
                cmp #$40
                bcc pt_printok
                sbc #$40
pt_printok:     sta (scrolltemp1),y
                iny
                jmp pt_printloop
pt_printend:    iny
                tya
                clc
                adc textlo
                sta textlo
                bcc pt_notover3
                inc texthi
pt_notover3:    tya
                clc
                adc scrolltemp1
                sta scrolltemp1
                bcc pt_notover4
                inc scrolltemp2
pt_notover4:    rts
printtext_getpos:
                txa
                pha
                ldx screen
                lda #$00
                sta scrolltemp1
                lda scradrtblhi,x
                sta scrolltemp2
                pla
                clc
                adc scrolltemp1
                sta scrolltemp1
                bcc pt_notover1
                inc scrolltemp2
pt_notover1:    tya
                beq pt_posdone
                lda scrolltemp1
                clc
                adc #40
                sta scrolltemp1
                bcc pt_notover2
                inc scrolltemp2
pt_notover2:    dey
                jmp pt_notover1
pt_posdone:     rts

;Ŀ
;TITLECOLORS                                                                  
;                                                                             
;Scrolls titlescreen colors.                                                  
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

titlecolors:    lda tcoldelay
                clc
                adc #$01
                cmp #$04
                bcc tc_yes
                sta tcoldelay
tc_yes:         lda #$00
                sta tcoldelay
                inc tcolcnt
                lda tcolcnt
                and #$0f
                lsr
                tay
                ldx #39
tc_loop1:       lda tcoltbl1,y
                sta $d800+5*40,x
                lda $d800+8*40,x
                sta $d800+7*40,x
                lda $d800+9*40,x
                sta $d800+8*40,x
                lda $d800+10*40,x
                sta $d800+9*40,x
                lda $d800+11*40,x
                sta $d800+10*40,x
                lda $d800+12*40,x
                sta $d800+11*40,x
                lda $d800+13*40,x
                sta $d800+12*40,x
                lda $d800+14*40,x
                sta $d800+13*40,x
                lda $d800+15*40,x
                sta $d800+14*40,x
                lda $d800+16*40,x
                sta $d800+15*40,x
                lda tcoltbl2,y
                sta $d800+16*40,x
                dex
                bpl tc_loop1
                rts

;Ŀ
;HISCORECOLORS                                                                
;                                                                             
;Scrolls hiscore colors.                                                      
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

hiscorecolors:  lda tcoldelay
                clc
                adc #$01
                cmp #$04
                bcc hscl_yes
                sta tcoldelay
hscl_yes:       lda #$00
                sta tcoldelay
                inc tcolcnt
                lda tcolcnt
                lsr
                and #$07
                sta charmapx
                clc
                adc #$04
                and #$07
                sta charmapy
                ldx #39
hscl_loop:      ldy charmapx
                lda tcoltbl1,y
                sta $d800+8*40,x
                sta $d800+9*40,x
                ldy charmapy
                lda tcoltbl2,y
                sta $d800+11*40,x
                dex
                bpl hscl_loop
                rts

;Ŀ
;CUTSCENE                                                                     
;                                                                             
;Shows a cutscene. Destroys map- block and chardatas.                         
;                                                                             
;Parameters: A:cutscenen numero                                               
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

cutscene:       tax
                ldy cutscenetune,x
                sty cutscene_m+1
                ldx #"C"
                clc
                adc #"0"
                tay
                jsr load
                ldy #$ff                        ;Mark level graphics as
                sty loadedlevel                 ;destroyed so that they'll be
                iny                             ;reloaded
                sty setbg
                jsr clearsprites
cutscene_m:     lda #MUS_CUTSCENE
                jsr playtune
                jsr initscroll
                lda #$18
                sta r2_setx+1
                lda #$01
                jsr clearscreen2
                lda #SCRM_GAME
                sta screenmode
                lda #<CUTSCENE
                sta textlo
                lda #>CUTSCENE
                sta texthi
                jsr cuts_resettxt
                jsr cuts_hide
cuts_loop:      ldy #$00                        ;Get next command
                lda (textlo),y
                iny
                asl
                tax
                lda cuts_jtbl,x                 ;Execute it
                sta cuts_jump+1
                lda cuts_jtbl+1,x
                sta cuts_jump+2
cuts_jump:      jsr $0000
cuts_next:      lda textlo
                clc
cuts_add:       adc #$00
                sta textlo
                bcc cuts_loop
                inc texthi
                jmp cuts_loop
cuts_jtbl:      dc.w cuts_show
                dc.w cuts_hide
                dc.w cuts_text
                dc.w cuts_clrscr
                dc.w cuts_delay
                dc.w cuts_end
                dc.w cuts_bigpic

cuts_show:      lda (textlo),y
                sta scrolltemp1
                iny
                lda (textlo),y
                sta scrolltemp2
                iny
                lda (textlo),y
                sta setmc1
                iny
                lda (textlo),y
                sta setmc2
                iny
                lda (textlo),y
                sta cuts_showcolor+1
                iny
                sty cuts_add+1
                ldx screen
                lda #9
                sta cuts_showrows+1
                lda #20
                sta cuts_showcols+1
                lda scradrtblhi,x
                ldy #1*40+10
                jsr cuts_showcopy
                lda #>COLORS
                ldy #1*40+10
                jsr cuts_showfill
                jsr waitraster
                jsr cuts_copychars
                rts

cuts_copychars: ldy #$00
                lda #<(CHARS+64*8)
                sta scrolltemp3
                lda #>(CHARS+64*8)
                sta scrolltemp4
cuts_copychars2:lda (scrolltemp1),y
                sta (scrolltemp3),y
                iny
                bne cuts_copychars2
                inc scrolltemp2
                inc scrolltemp4
                lda scrolltemp4
                cmp #>(CHARS+2048)
                bcc cuts_copychars2
                rts

cuts_showcopy:  sta scrolltemp4
                sty scrolltemp3
cuts_showrows:  ldx #$00
cuts_showcols:  ldy #$00
                dey
cuts_show2:     lda (scrolltemp1),y
                sta (scrolltemp3),y
                lda scrolltemp4
                dey
                bpl cuts_show2
                lda scrolltemp1
                clc
                adc cuts_showcols+1
                sta scrolltemp1
                bcc cuts_show3
                inc scrolltemp2
cuts_show3:     lda scrolltemp3
                clc
                adc #40
                sta scrolltemp3
                bcc cuts_show4
                inc scrolltemp4
cuts_show4:     dex
                bne cuts_showcols
                rts

cuts_showfill:  sta scrolltemp4
                sty scrolltemp3
                ldx cuts_showrows+1
cuts_showf1:    ldy cuts_showcols+1
                dey
cuts_showcolor: lda #$00
                sta (scrolltemp3),y
                lda scrolltemp4
                dey
                bpl cuts_showcolor
                lda scrolltemp3
                clc
                adc #40
                sta scrolltemp3
                bcc cuts_showf4
                inc scrolltemp4
cuts_showf4:    dex
                bne cuts_showf1
                rts

cuts_hide:      sty cuts_add+1
                jsr waitraster
                lda #$00
                tax
cuts_hideloop:  sta CHARS+$200,x
                sta CHARS+$300,x
                sta CHARS+$400,x
                sta CHARS+$500,x
                sta CHARS+$600,x
                sta CHARS+$700,x
                inx
                bne cuts_hideloop
                rts

cuts_text:      sty alo
                jsr waitraster
                jsr getcontrols
                jsr getfireclick
                bcs cuts_end
                ldy alo
                lda (textlo),y
                beq cuts_printend
                and #$3f
cuts_printpos:  sta SCREEN1,y
                iny
                jmp cuts_text
cuts_printend:  iny
                sty cuts_add+1
                lda cuts_printpos+1
                clc
                adc #40
                sta cuts_printpos+1
                bcc cuts_printok
                inc cuts_printpos+2
cuts_printok:   rts

cuts_end:       pla
                pla
                lda #SCRM_BLANK
                sta screenmode
                jsr clearscreen
                jsr clearsprites
                lda #$ff                  ;All sprites multicolor again
                sta r2_setmulticol+1
                rts

cuts_delay:     lda (textlo),y
                iny
                sty cuts_add+1
                sta alo
cuts_delay1:    jsr waitraster
                jsr getcontrols
                jsr getfireclick
                bcs cuts_end
                dec alo
                bne cuts_delay1
                rts

cuts_clrscr:    sty cuts_add+1
                jsr cuts_resettxt
                ldx #$05
cuts_clrloop1:  ldy #$01
cuts_clrloop2:  lda #$20
                sta (scrolltemp3),y
                iny
                cpy #39
                bcc cuts_clrloop2
                lda scrolltemp3
                clc
                adc #40
                sta scrolltemp3
                bcc cuts_clr3
                inc scrolltemp4
cuts_clr3:      dex
                bne cuts_clrloop1
                rts

cuts_resettxt:  lda #184
                sta scrolltemp3
                sta cuts_printpos+1
                ldx screen
                ldy scradrtblhi,x
                iny
                sty scrolltemp4
                sty cuts_printpos+2
                rts

        ;Hovercar animation in the end

cuts_bigpic:    jsr clearscreen
                ldy #$01
                lda (textlo),y
                sta scrolltemp1
                iny
                lda (textlo),y
                sta scrolltemp2
                iny
                tya
                clc
                adc textlo
                sta textlo
                bcc cuts_bigpic2
                inc texthi
cuts_bigpic2:   lda #10
                sta setmc1
                lda #11
                sta setmc2
                ldx screen
                lda #11
                sta cuts_showrows+1
                lda #40
                sta cuts_showcols+1
                lda scradrtblhi,x
                ldy #3*40
                jsr cuts_showcopy
                lda #>COLORS
                ldy #3*40
                jsr cuts_showcopy
                jsr waitraster
                jsr cuts_copychars

cuts_ending:    ldx #$3e
cuts_ending2:   lda cuts_sprite,x
                sta BOSS,x              ;Copy the sprite to sprite 32
                dex
                bpl cuts_ending2
                lda #72
                sta sprx
                lda #114
                sta spry
                lda #32
                sta sprf
                lda #0
                sta sprfls
                sta cuts_hcdx
                sta cuts_hcdx2
                sta cuts_hcdy
                sta cuts_hcc
                sta cuts_hcxdec
                sta cuts_hcydec
                sta sprxh
                lda #110
                sta cuts_hcd
cuts_ending3:   jsr waitraster
                jsr getcontrols
                jsr getfireclick
                bcc cuts_noend
                jmp cuts_end
cuts_noend:     lda #$01
                sta numspr
                lda cuts_hcc
                clc
                adc #$01
                and #$03
                sta cuts_hcc
                tax
                lda cuts_hcctbl,x
                sta SPRCOLS+32
                jsr updatesprites
                inc newsprites
                lda cuts_hcxdec
                clc
                adc cuts_hcdx
                sta cuts_hcxdec
                lda sprx
                adc cuts_hcdx2
                sta sprx
                lda sprxh
                adc #$00
                sta sprxh
                lda cuts_hcydec
                sec
                sbc cuts_hcdy
                sta cuts_hcydec
                lda spry
                sbc #$00
                sta spry
                lda cuts_hcd
                beq cuts_ending7
                dec cuts_hcd
                jmp cuts_ending5
cuts_ending7:   lda spry
                cmp #108
                bcc cuts_ending6
                lda cuts_hcdy
                clc
                adc #$04
                sta cuts_hcdy
                jmp cuts_ending5
cuts_ending6:   lda cuts_hcdy
                beq cuts_ending8
                dec cuts_hcdy
cuts_ending8:   lda cuts_hcdx
                clc
                adc #$03
                sta cuts_hcdx
                lda cuts_hcdx2
                adc #$00
                sta cuts_hcdx2
cuts_ending5:   lda sprxh
                beq cuts_ending9
                lda sprx
                cmp #128
                bcs cuts_ending10
cuts_ending9:   jmp cuts_ending3

          ;Show the final texts with sprites

cuts_ending10:  jsr clearsprites  ;Sprites off
                lda #$00          ;Set sprites single-colored
                sta r2_setmulticol+1
                tax
cuts_ending11:  sta BOSS,x        ;Clear 24 sprites
                sta BOSS+$100,x
                sta BOSS+$200,x
                sta BOSS+$300,x
                sta BOSS+$400,x
                sta BOSS+$500,x
                inx
                bne cuts_ending11
                ldx #$17
cuts_ending12:  lda #$01
                sta SPRCOLS+32,x  ;Change sprite colors to white and reset
                lda #$00          ;flashing
                sta sprfls,x
                txa
                clc
                adc #$20
                sta sprf,x
                dex
                bpl cuts_ending12
                ldx #$07
cuts_ending13:  lda #84           ;Set sprite X & Y coords
                sta spry,x
                lda #84+28
                sta spry+8,x
                lda #84+56
                sta spry+16,x
                lda cuts_sprxtbl,x
                sta sprx,x
                sta sprx+8,x
                sta sprx+16,x
                lda cuts_sprxhtbl,x
                sta sprxh,x
                sta sprxh+8,x
                sta sprxh+16,x
                dex
                bpl cuts_ending13
                lda #$18
                sta numspr
                jsr updatesprites
                jsr waitraster
                inc newsprites
                lda #$00
                sta cuts_charpos
                sta cuts_chardelay
cuts_ending14:  jsr waitraster    ;Wait...
                jsr waitraster
                jsr getcontrols
                jsr getfireclick
                bcc cuts_ending15
                jmp cuts_end
cuts_ending15:  lda cuts_chardelay
                beq cuts_ending16
                ldy #$00
                lda (textlo),y          ;Delay 0 = infinite
                beq cuts_ending14
                dec cuts_chardelay
                jmp cuts_ending14
cuts_ending16:  lda cuts_charpos
                sta scrolltemp1
                lda #$00
                sta scrolltemp2
                tay                     ;First row
                lda (textlo),y
                jsr cuts_sprwrite
                inc scrolltemp2
                ldy #24                 ;Second...
                lda (textlo),y
                jsr cuts_sprwrite
                inc scrolltemp2
                ldy #48
                lda (textlo),y
                jsr cuts_sprwrite
                inc scrolltemp2
                ldy #72
                lda (textlo),y
                jsr cuts_sprwrite
                inc scrolltemp2
                ldy #96
                lda (textlo),y
                jsr cuts_sprwrite
                inc scrolltemp2
                ldy #120
                lda (textlo),y
                jsr cuts_sprwrite
                inc textlo
                bne cuts_ending17
                inc texthi
cuts_ending17:  inc cuts_charpos
                lda cuts_charpos
                cmp #24
                bcc cuts_ending18
                lda #$00
                sta cuts_charpos
                lda #250
                sta cuts_chardelay
                lda textlo
                clc
                adc #120
                sta textlo
                bcc cuts_ending18
                inc texthi
cuts_ending18:  jmp cuts_ending14

          ;Subroutine for writing a letter into a sprite.
          ;Scrolltemp1 contains X-pos, scrolltemp2 contains Y-pos and A
          ;contains the letter.

cuts_sprwrite:  and #$3f
                stx cuts_swxsave+1
                sty cuts_swysave+1
                pha
                ldx scrolltemp1
                lda sprwritextbllo,x
                sta scrolltemp3
                lda sprwritextblhi,x
                sta scrolltemp4
                lda scrolltemp2
                lsr
                bcc cuts_sprwrite2
                pha
                lda scrolltemp3
                adc #41
                sta scrolltemp3
                pla
cuts_sprwrite2: tax
                lda sprwriteytblhi,x
                clc
                adc scrolltemp4
                sta scrolltemp4
                pla
                tax
                asl
                asl
                asl
                sta cuts_sprwrite3+1
                txa
                lsr
                lsr
                lsr
                lsr
                lsr
                clc
                adc #>CHARS
                sta cuts_sprwrite3+2
                ldy #$00
                ldx #$00
cuts_sprwrite3: lda $1000,x
                sta (scrolltemp3),y
                iny
                iny
                iny
                inx
                cpx #$07
                bcc cuts_sprwrite3
cuts_swxsave:   ldx #$00
cuts_swysave:   ldy #$00
                rts

